/**
 * 常用变量与函数的定义
 * $Date: 2015-07-18 11:32:48 +0800 (周六, 2015-07-18) $
 * $Revision: 4867 $
 * $Author: wangpenghui $
 */
/*============================ 本地存储数据一览表 =======================================

 Account:     				普通业务多账户信息
 ActivePTJYUser:  			普通业务当前用户信息
 ActiveRZRQUser:  			融资融券业务当前用户信息

 page:        		  		跳转界面
 zqdm:        				行情,持仓界面保存的证券代码

 apiUrl 						交易服务器地址
 timeOut 					设置请求超时时间
 dataList					页面传值对象

 khbsList;					普通交易登录的客户账号集合(下拉框显示需要)
 remember					普通交易记录账号

 rzrq_khbzList				融资融券登录的客户账号集合(下拉框显示需要)
 rzrq_remember				融资融券记录账号

 kds_ywxt					业务系统	( 0: 普通交易; 1: 融资融券 )

ipandport					微信商城 URL

普通业务测试登录账号 		(1) 100001742 (2) 1100009289 		登录密码 111111
融资融券测试登录账号 		84200009							登录密码 111111

 ====================================================================================*/

/*============================ common.js 普通函数功能列表 =================================

 loadding.run();													页面弹框显示加载状态
 loadding.stop();												去掉加载状态

 ajaxPost(url,jsonData,method,errorMethod);						web前后端通信

 getformdata();													获取表单数据	文本框添加属性：isSub="true"

 IsSuccess(response,errorMethod);								是否成功

 Logout();														注销用户登录信息

 showMessageTips(obj);											模拟APP显示提示信息

 setNotIOSSystemTouch()                      					设置非ios系统的滑屏滚动

 RecordCheckBox(obj)                         					记录复选框的状态

 getBrowser();													获取浏览器类型	pc/android/ios

 trim(str):                              						去除字符串中的空格回车

 setLocalListData(listName,value):       						存储列表数据

 removeLocalListData(listName,value):    						清除列表中指定字段

 getLocalData(key):                      						获取本地存储数据

 removeLocalData(key):                   						清除本地存储数据

 clearLocalData():                       						清空本地存储数据

 QuickJump(viewKey)                          					快捷跳转

 getfirsthref()													获取当前URL地址前半部分
 getlasthref()													获取当前URL地址后半部分

 plusMinus(id,type,step,fixed)									加减

 create_modal($scope,$compile,modal) 							创建模态框

 formatDate(date, format)										格式化字符串日期

 getMarkInfo()													获取留痕信息

 saveLog(str)													保存日志到本地数据库
 selectLog()														查询本地数据库里的日志信息
 clearLog()														清空数据库表数据

 formatResponseData(response)									对返回数据中的列表数据进行非空处理

 getHqTime()														获取行情刷新时间

 updateClass(fileName, className, method)						修改文件样式

 resetScroll()													重置滚动条

 haveLogged()													已经登录

isVersionHengSheng2_0											当前是否是恒生柜台 2.0版本（是：true，否：false）

=====================================================================================*/

/*============================ 与原生 APP 交互的函数 ==================================

 showKeyboard(id,type);											显示 APP 自定义键盘
 hideKeyBoard()													隐藏 APP 自定义键盘
 closeKeyBoard()													关闭 APP 自定义键盘回调函数

 fillInputContent(param);										自定义键盘回调函数

 JumpInterface(url, hasRefresh, direction);						跳转界面

 jumpToView();													快捷跳转页面

 setApiUrl(apiUrl);												设置交易服务器地址
 getApiUrl();													获取交易服务器地址

 setTimeOut(timeOut);											设置请求超时时间 (无效)

 getTimeOut();													获取请求超时时间 (无效)

 selfserviceAccount()											自助开户

 getLoginAccount()												获取资金账号

 setMarkInfo(obj)												设置留痕信息

 setIsRegister(phone)											设置是否注册
 getIsRegister()												获取是否注册
 showRegisterView()												显示注册界面

 addUserStock(stockName,stockCode,marketId)						添加自选股

 saveOrUpdateLocalData(key, value)								保存或修改本地存储

 getVersion()													获取版本号

 timerAction(timerName, actionType)								调用APP 锁屏计时器

 TimeoutHandler(ywlx)											登录超时处理函数

 setLocalData(key,value):                						设置本地存储数据

 setHqTime(time)													设置行情时间 (单位: 秒)

 CloseModal()                 									移除模态框

 setAppVersion(version)											设置 App 版本号

 setDgPersonalIpAndPort(json)									设置东莞个性化数据的IP和端口，比如：商城、个人中心的IP部分

 initSaleInfo(value)												获取营业部信息（西藏同信）
 onLoginTrade(value)											传递用户交易登录信息(姓名，电话)给原生
 ======================================================================================*/

var order = {
    multiGD: false,                //多股东标志位
    mmlb: "",                      //买卖类别
    gznhg: false,                  //国债逆回购
    curzqdm: "",                   //证券代码当前值和历史值
    lastzqdm: "",
    curgddm: "",                   //股东代码当前值和历史值
    lastgddm: "",
    curjysdm: "",                  //交易所代码当前值和历史值
    lastjysdm: "",
    isNeverInputPrice: true,       //是否输入过价格
    isHideLoad: false,             //隐藏加载动画
    isMouseLeavePriceInput: true,  //光标是否离开了输入框
    isStopAutoQuery: false        //是否停止自动刷新
};

var params = {};

// 交易版本
// tongyong :   通用版本,功能最全的版本;                               代表客户: 东证
// jzwin    :   金证 win 版,融资融券部分界面及柜台与主干版本不同;      代表客户：万和
// pacific  :   太平洋项目版本,与主干版本的差异就是没有开放式基金;

params['jybblx'] = "jzwin";
//params['jybblx']	= "tongyong";
// 柜台版本
params['gtbb'] 		= "2.0";

//----------证券公司常量----------
/** 东莞证券*/
const ZQGS_DONGZHENG = "dongZheng";
/** 万和*/
const ZQGS_WANHE = "wanHe";
/** 西藏同信*/
const ZQGS_TONGXIN = "tongXin";
/** 华龙小金*/
const ZQGS_HUALONGXIAOJIN = "huaLongxiaojin";
/** 华西证券*/
const ZQGS_HUAXI = "huaXi";
/** 世纪证券*/
const ZQGS_SHIJI = "shiJi";
/** 中信建投*/
const ZQGS_ZHONGXIN = "zhongXinJianTou";
/** 华龙新版*/
const ZQGS_HUALONGXINBAN = "huaLongXinBan";

// 证券公司
params["zqgs"] = ZQGS_TONGXIN;

/** 是否是指定公司版本*/
function isAppointedCompony(companyName){
    return companyName == params["zqgs"];
}

// 云平台测试地址
var apiUrl = "";
if (ZQGS_WANHE == params['zqgs']) {
    //万和
    apiUrl = "https://183.239.173.35:21900/api/trade/";
} else if (ZQGS_TONGXIN == params['zqgs']) {
    //同信
    apiUrl = "https://116.228.223.102:21900/api/trade/";
    //apiUrl = "https://192.168.230.225:21900/api/trade/";
} else if (ZQGS_HUALONGXIAOJIN == params['zqgs']) {
    //华龙小金
    apiUrl = "https://61.178.60.211:21900/api/trade/";
} else if (ZQGS_HUAXI == params['zqgs']) {
    //华西
    apiUrl = "https://125.71.215.163:21900/api/trade/";
    //生产地址
    //apiUrl = "https://182.131.7.198:21800 /api/trade/";
} else if( ZQGS_SHIJI == params['zqgs']){
    //世纪
    apiUrl = "https://61.141.193.117:21900/api/trade/";
}else if(ZQGS_ZHONGXIN == params['zqgs']){
    //中信建投
    //apiUrl = "https://192.168.230.222:21900/api/trade/";
    apiUrl = "http://111.13.63.1:21900/api/trade/";
} else if(ZQGS_HUALONGXINBAN == params['zqgs']){
    //华龙新版
    apiUrl = "https://192.168.230.223:21900/api/trade/";
}
params['apiUrl'] = apiUrl;

// 太平洋柜台测试地址
// params['apiUrl'] = "https://220.163.101.91:21900/api/trade/";
// 东莞柜台测试地址
// params['apiUrl'] = "https://113.78.134.110:21900/api/trade/";
// Win版测试地址
//params['apiUrl'] = "https://192.168.230.213:21900/api/trade/";

// 测试专用ID	上传到svn时改成0,不影响他人开发
params['testid'] = 0;
// 版本号	重大版本更新 / 年 / 月 / 日 / 累计更新版本次数 ( 打包文件格式为 zip )
params['version'] = "v 1.0.0.0.10";
// 控件ID(调用键盘时保存的ID)
params['id'] = "";
// 模态框类型
params['modaltype'] = 0;
// 普通交易定时器名称
params['ptjytimer'] = "ptjy";
// 融资融券定时器名称
params['rzrqtimer'] = "rzrq";
//服务器返回的成功状态
params['code'] = "0";
// 刷新行情频率
params['sxhqpl'] = getHqTime();
// 请求行数
params['qqhs'] = "50";
// 是否自动刷新委托数量输入框提示语
params['isNeverInputVolume'] = true;
// 查询方向
params['cxfx'] = "1";
// 业务类型 ptjy: 普通交易; rzrq: 融资融券

params['ywlx'] = document.body==undefined ? "" : (document.body.getAttribute("data-ywlx") || "");

// 新股申购请求地址
//params['apiUrlNews']		= "http://www.app519.com:21800/api/news/";
params['apiUrlNews'] = "http://113.78.134.110:21800/api/news/";
// params['apiUrlNews'] = "http://192.168.230.225:21800/api/news/";

// 是否注册	true: 已注册  false: 未注册
params['isRegister'] = getIsRegister();
// 是否是低版本
params['lowVersion'] = false;
// 浏览器	pc/android/ios
params['browser'] = getBrowser();
// params['browser'] = "pc";

// 请求超时时间(默认,PC浏览器测试需要),单位分钟
params['timeOut'] = 11;
// 是否隐藏 DIV 下拉框
params['isHideDivSelect'] = false;
// 重置滚动条位置
params['scrollTop'] = 0;
// 滚动条位置偏移量
params['topPyl'] = 0;
// 计数
params['count'] = 1;
// URL 临时地址
params['urltmp'] = "";
// 银行代码(主流的)
params['yhdms'] = ['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '12', '13', '14', '19', '20'];

params['querytitle'] = {
    "jjcc": "基金持仓",
    "zjls": "资金流水",
    "wtcj": "委托成交",
    "day": "当日",
    "week":"一周内",
    "month": "一个月内",
    "year": "半年内",
    "custom":"»" //用户自行填选
};

// 客户代码-币种 对应关系
params['bz'] = {
    "0": "RMB",
    "1": "HKD",
    "2": "USD"
};
// 货币代码-货币名称 对应关系
params['bzmc'] = {
    "0": "元",
    "1": "港元",
    "2": "美元"
};
// 客户代码-买卖方向 对应关系
params['mmfx'] = {
    "0": "买入",
    "1": "卖出"
};
// 客户代码-委托状态 对应关系
params['wtzt'] = {
    "0": "未报",
    "1": "正报",
    "2": "已报",
    "3": "已报待撤",
    "4": "部成待撤",
    "5": "部撤",
    "6": "已撤",
    "7": "部成",
    "8": "已成",
    "9": "废单",
    "A": "待报",
    "B": "正报"
};

// 需要保存到 APP 里的本地存储的键
params['appKey'] = ["ptjyLszhList", "rzrqLszhList", "ptjyJZZH", "rzrqJZZH", 'trade_login_default_key"'];

// 页面快捷跳转入口	[与APP交互使用,key值不能随意修改]
params["viewKey"] = {

    "KDS_SM_WTJY": "ptjy/home/ptjy_index.html"	        	    	// 普通交易-委托交易
    , "KDS_SM_ZCCX": "ptjy/home/ptjy_index.html"	        		// 普通交易-资产查询
    , "KDS_Buy": "ptjy/wtxd/ptjy_wtmr.html"	        		        // 普通交易-买入
    , "KDS_Sell": "ptjy/wtxd/ptjy_wtmc.html"	      			    // 普通交易-卖出
    , "KDS_CheDan": "ptjy/chache/ptjy_wtcd.html"					// 普通交易-撤单
    , "KDS_SM_CCQuery": "ptjy/chache/ptjy_cccx.html"				// 普通交易-持仓查询
    , "KDS_Query": "ptjy/chache/ptjy_wtcj_zjls.html"                // 普通交易-查询

    // 内部跳转界面
    , "KDS_PTJYLogin": "ptjy/login/ptjy_login.html"	   			    	// 普通交易-登录
    , "KDS_PTJYHeader": "ptjy/home/ptjy_header.html"	  				// 普通交易-首页
    , "KDS_PTJYIndex": "ptjy/home/ptjy_index.html"                  	// 普通交易-主页

    , "KDS_PTJY_XGMM": "ptjy/xgmm/ptjy_xgmm.html"                   	// 普通交易-修改密码
    , "KDS_PTJY_ZJDD": "ptjy/zjdd/ptjy_zjgj.html"                   	// 普通交易-资金调度
    , "KDS_PTJY_ZJDB": "ptjy/zjdd/ptjy_zjdb.html"                   	// 普通交易-资金调拨
    , "KDS_PTJY_ZJLS": "ptjy/zjdd/ptjy_dbls.html"                       // 普通交易-资金流水

    , "KDS_PTJY_ZZCX": 'ptjy/yzzz/ptjy_zzcx.html'              	   	// 普通交易-转账查询
    , "KDS_SM_YZZZ": "ptjy/yzzz/ptjy_yzzz.html"					    // 普通交易-银证转账
    , "KDS_SM_XGSG": "ptjy/xgsg/ptjy_xgsg.html"				    	// 普通交易-新股申购
    , "KDS_PTJY_XGCX": "ptjy/xgsg/ptjy_xgcx.html"					// 普通交易-新股申购查询

    , "KDS_RZRQLogin": "rzrq/home/rzrq_login.html"	   	    			// 融资融券-登录
    , "KDS_RZRQHeader": "rzrq/home/rzrq_header.html"	      			// 融资融券-首页
    , "KDS_RZRQIndex": "rzrq/home/rzrq_index.html"	      				// 融资融券-主页

    , "KDS_RZRQ_RZMR": "rzrq/wtxd/rzrq_rzmr.html"	  					// 融资融券-融资买入
    , "KDS_RZRQ_RQMC": "rzrq/wtxd/rzrq_rqmc.html"	  					// 融资融券-融券卖出
    , "KDS_RZRQ_PTMR": "rzrq/wtxd/rzrq_ptmr.html"	  					// 融资融券-普通买入
    , "KDS_RZRQ_PTMC": "rzrq/wtxd/rzrq_ptmc.html"	  					// 融资融券-普通卖出
    , "KDS_RZRQHuanKuan": "rzrq/wtxd/rzrq_huankuan.html" 				// 融资融券-还款
    , "KDS_RZRQHuanQuan": "rzrq/wtxd/rzrq_huanquan.html" 				// 融资融券-还券
    , "KDS_RZRQ_DBPHZ": "rzrq/wtxd/rzrq_dbphz.html" 					// 融资融券-担保品划转

    , "KDS_RZRQ_CCCX": "rzrq/chache/rzrq_cccx.html"                   	// 融资融券-持仓查询
    , "KDS_RZRQ_WTCD": "rzrq/chache/rzrq_wtcd.html" 					// 融资融券-委托撤单

    , "KDS_RZRQ_WTCJ_ZJLS_Query": "rzrq/chache/rzrq_wtcj_zjls_query.html"		// 融资融券-委托成交 资金流水查询
    , "KDS_RZRQ_DBP_KRZRQ_Query": "rzrq/chache/rzrq_dbp_krzrq_query.html"		// 融资融券-担保品   可融资 融券查询
    , "KDS_RZRQ_RZRQFZ_HYCX_Query": "rzrq/chache/rzrq_rzrqfz_hycx_query.html"	// 融资融券-融资融券负债 已了结合约查询
    , "KDS_RZRQ_XYZC_HYXQ_Query": "rzrq/chache/rzrq_xyzc_hyxq_query.html"	 	// 融资融券-信用资产 合约详情查询
    , "KDS_RZRQ_XYFZCX_Win_Query": "rzrq/chache/rzrq_xyfzcx_win_query.html"	    // 融资融券-信用负债资产查询(win版)
    , "KDS_RZRQ_HYCHSXSX_Query": "rzrq/hychsxsz/rzrq_hychsxcx.html"			    // 融资融券-合约偿还顺序查询

    , "KDS_RZRQ_XGMM": 'rzrq/xgmm/rzrq_xgmm.html'                	// 融资融券-修改密码
    , "KDS_RZRQ_YZZZ": 'rzrq/yzzz/rzrq_yzzz.html'                	// 融资融券-银证转账
    , "KDS_RZRQ_ZZCX": 'rzrq/yzzz/rzrq_zzcx.html'                	// 融资融券-转账查询
    , "KDS_RZRQ_XGCX": 'rzrq/xgsg/rzrq_xgcx.html'                	// 融资融券-新股查询
    , "KDS_RZRQ_XGSG": 'rzrq/xgsg/rzrq_xgsg.html'                	// 融资融券-新股申购


    , "KDS_KFSJJ_Index": "kfsjj/home/kfsjj_index.html"                        // 开放式基金-主页
    , "KDS_SM_KFSJJ": "kfsjj/home/kfsjj_index.html"                        // 开放式基金-主页

    , "KDS_KFSJJ_JJSG": 'kfsjj/jjjy/kfsjj_jjsg.html'                         // 开放式基金-基金申购
    , "KDS_KFSJJ_JJRG": 'kfsjj/jjjy/kfsjj_jjrg.html'                         // 开放式基金-基金认购
    , "KDS_KFSJJ_JJSH": 'kfsjj/jjjy/kfsjj_jjsh.html'                         // 开放式基金-基金赎回
    , "KDS_KFSJJ_JJZH": 'kfsjj/jjjy/kfsjj_jjzh.html'                         // 开放式基金-基金转换
    , "KDS_KFSJJ_FHSZ": 'kfsjj/jjjy/kfsjj_fhsz.html'                         // 开放式基金-分红设置

    , "KDS_KFSJJ_JJCD": 'kfsjj/jycx/kfsjj_jjcd.html'                         // 开放式基金-基金撤单
    , "KDS_KFSJJ_JJXX": 'kfsjj/jycx/kfsjj_jjxx.html'                         // 开放式基金-基金信息
    , "KDS_KFSJJ_JYCX": 'kfsjj/jycx/kfsjj_wtcj_cccx.html'                    // 开放式基金-交易查询
    , "KDS_KFSJJ_ZHCX": 'kfsjj/jycx/kfsjj_zhcx.html'                         // 开放式基金-基金账户查询
    , "KDS_KFSJJ_JJKH": 'kfsjj/jjkh/kfsjj_jjkh.html'                         // 开放式基金-基金开户
    , "KDS_KFSJJ_FXTS": 'kfsjj/jjkh/kfsjj_fxts.html'                         // 开放式基金-风险提示

    , "KDS_KFSJJ_JJDTS": 'kfsjj/jjdts/jjdts.html'                        	// 开放式基金-基金定投/基金定赎
    , "KDS_KFSJJ_DTSSQ": 'kfsjj/jjdts/dtssq.html'                        	// 开放式基金-基金定投申请/基金定赎申请
    , "KDS_KFSJJ_DTSXQ": 'kfsjj/jjdts/dtsxq.html'                        	// 开放式基金-基金定投详情/基金定赎详情

    //电子签约
    , "KDS_DZQY_FXCP_START": 'ptjy/dzqy/fxcp/dzqy_evaluationStart.html'          // 电子签约-风险测评
    , "KDS_DZQY_RISK_TIP": 'ptjy/dzqy/fxts/dzqy_riskTip.html'                    // 电子签约-签约（撤销）
    , "KDS_DZQY_RISK_START": 'ptjy/dzqy/fxcp/dzqy_evaluationStart.html'          // 电子签约-开始答题提示
    , "KDS_DZQY_RISK_EVALUATION": 'ptjy/dzqy/fxcp/dzqy_riskEvaluation.html'      // 电子签约-答题
    , "KDS_DZQY_RISK_RESULT": 'ptjy/dzqy/cpjg/dzqy_evaluationResult.html'        // 答题结果
    , "KDS_DZQY_LIST": 'ptjy/dzqy/xylb/dzqy_agreementList.html'                  // 签约列表

};

// 消息提示
params['message'] = {};
params['message']['yzzz_success'] = "转账请求已提交，请在“查流水”中查看转账结果！"; // 银证转账_成功
params['message']['xgmm_success'] = "修改密码成功";
params['message']['xgsg_success'] = "委托下单成功"; // 新股申购 委托下单成功
params['message']['zjhz_success'] = "委托下单成功"; // 资金划转 委托下单成功

/*================================ 测试使用 start ===========================*/
if (params.testid == 1) {
    params['browser'] = "pc";
    params['apiUrl'] = "http://192.168.191.1:90/api/trade/";
    // params['apiUrlNews'] = "http://192.168.191.1/api2/news/xgsg";
}
/*================================ 测试使用 end =============================*/

/*========================= 重写 console.log 函数 ===========================*/
if (getBrowser() == "ios") {
    console.log = (function(oriLogFunc) {
        return function(str) {
            loadURL("KDS_Native://log:" + str);
        }
    })(console.log);
}

/**
 * ajax 请求时，显示 loadding 加载状态
 * loadding.run();    页面弹框显示加载状态
 * loadding.stop();    去掉加载状态
 */
var loadding = {
    run: function () {
        if ($("#loading").length == 0) {
            $("body").append('<div id="loading"><div class="loading-circle"></div></div>');
            $("#loading").show();
        }
    },
    stop: function () {
        $("#loading").remove();
    }
};

/*====================================================================
 函数功能: 	web 前后端通信
 传入参数: 	url 			: 请求地址
 jsonData		: 传递参数
 method 			: 处理函数
 errorMethod		: 错误处理函数(不传则使用默认处理)
 options 		: 其它参数的一个对象(使用第5个入参时,第四个入参不需要则传null)
 =======================================================================*/
function ajaxPost(url, jsonData, method, errorMethod, options) {

    // 如果 APP 没有传交易服务器地址过来, 则弹出提示信息
    if (params.browser != "pc" && getLocalData("apiUrl") == null) {
        showAlert("当前没有可用的交易站点", "提示信息");
        return;
    }

    if (errorMethod == null) errorMethod = undefined;

    if (options == undefined) options = {};

    var defaults = {
        isloaddingrun: true,            // 是否执行 loadding.run(), 默认会执行 loadding.stop()
        iserror: true,                  // 是否弹出错误提示
        async: true,                    // 请求方式 true: 异步请求 false: 同步请求
        issuccess: true,                // 是否需要成功校验 true: 需要 false: 不需要
        isQHZD: false,                  // 是否是切换站点
        isLOGIN: false,                 // 是否是登录请求
        completeMethod: null,           // ajax 执行完成后回调的函数
        isloaddingstop: true,           // 是否执行 loadding.stop()
        errorMethod: null               // 执行完统一错误处理,不需要切换站点, 再回调的函数. (与 ajaxPost 中 errorMethod 入参的区别是: 入参中的回调函数不需要执行统一处理)
    };

    var options = $.extend(defaults, options);

    // 不是切换站点提交的请求时, 重新计数
    if (!options.isQHZD) {
        params.count = 1;

        // 将 URL 地址放入到全局变量中去(站点优选需要)
        params.urltmp = url;
    }

    // 除操作超时,普通交易登录,融资融券交易登录 请求需要提取保存的用户信息
    if (window.location.href.indexOf("ptjy_login") == -1 && window.location.href.indexOf("rzrq_login") == -1 && options.isLOGIN == false) {
        // 担保品划转
        if (document.title.trim() == "担保品划转") {
            if ($("#DBPHZType button.active").text().trim() == "普通转信用") {
                var ActiveUse = JSON.parse(getLocalData("dbphzPTJYUser"));
            } else if ($("#DBPHZType button.active").text().trim() == "信用转普通") {
                var ActiveUse = JSON.parse(getLocalData("ActiveRZRQUser"));
            }
        } // 融资融券
        else if (params.ywlx == "rzrq" && getLocalData("ActiveRZRQUser")) {
            var ActiveUse = JSON.parse(getLocalData("ActiveRZRQUser"));

        }
        // 普通交易和开放式基金使用的账号相同
        else if ((params.ywlx == "kfsjj" || params.ywlx == "ptjy") && getLocalData("ActivePTJYUser")) {
            var ActiveUse = JSON.parse(getLocalData("ActivePTJYUser"));
        } else {
            console.log("[ajaxPost] 用户信息丢失");
            return;
        }

        // 当登录类型为客户号, 使用服务器下发补全的客户代码
        var khbz = ActiveUse.head.khbzlx == "C" ? ActiveUse.body.dlxx[0].khdm : ActiveUse.head.khbz;

        if (isAppointedCompony(ZQGS_TONGXIN) && "Z" == ActiveUse.head.khbzlx) { //西藏同信，资金账号登录时，客户标志取返回的资金账号
            khbz = ActiveUse.body.dlxx[0].zjzh;
        }

        jsonData['khbz'] = khbz;                                                                // 登陆账号
        jsonData['khbzlx'] = ActiveUse.head.khbzlx;                                             // 客户标志类型

        jsonData['jymm'] = jsonData.jymm == undefined ? ActiveUse.head.jymm : jsonData.jymm;    // 交易密码
        jsonData['sessionid'] = jsonData['sessionid'] ? jsonData['sessionid'] : "0";            // 移动证券系统 APP 注册 ID, 由金慧盈通颁发和认证  [目前该字段服务器还未下发]

        jsonData['token'] = ActiveUse.body.dlxx[0].token || "0";                                // 账户会话ID，用户登录后由柜台下发和认证，首次登陆填空 [目前该字段服务器还未下发]
        jsonData['yybdm'] = ActiveUse.body.dlxx[0].yybdm;                                       // 营业部代码
    }

    jsonData['lhxx'] = getMarkInfo(); // 留痕信息

    // console.log("发送请求时间:"+new Date());
    console.log("[请求] " + url);
    console.log("[入参] " + JSON.stringify(jsonData));

    $.ajax({
        type: "POST",
        url: url,
        data: JSON.stringify(jsonData),
        timeout: getAjaxTimeOut(),
        contentType: "application/json; charset=utf-8",
        dataType: "json",
        async: defaults.async,
        cache: false,
        beforeSend: function() { //请求之前加载
            if (options.isloaddingrun) {
                loadding.run();
            }
        },

        success: function(response) {
            console.log("[出参] " + JSON.stringify(response));

            // 是否需要成功返回校验
            if (defaults.issuccess == true) {
                // 成功返回执行回调函数, 否则统一处理失败返回
                if (IsSuccess(response, errorMethod, options)) {
                    angular.element($("body")).scope().$apply(function() {
                        method(response);
                    });
                }
            } else {
                angular.element($("body")).scope().$apply(function() {
                    method(response);
                });
            }

        },

        error: function(request, status, error) {

            // console.log("请求结束时间:"+new Date());
            console.log("[报错] " + request.status, request.statusText, "error:" + error);

            //showAlert(request.status + " " + request.statusText, "提示信息");

            var errorText = "";

            if (request.status == 0) {
                if (request.statusText == "timeout") {
                    errorText = "您的网络不给力，请稍后再试。";
                } else {
                    errorText = "网络请求失败，请稍后再试。";
                }
            } else if (request.status == 400 || request.status == 404) {
                errorText = "网络连接失败。";
            } else if (request.status == 500 || request.status == 502) {
                errorText = "服务器繁忙，请稍后再试。";
            } else {
                errorText = "网络请求失败，稍后再试。";
            }

            if (options.iserror) {
                showAlert(errorText, "提示信息");
            }

            if ((request.status == 0 && request.statusText == "timeout") ||
                request.status == 400 || request.status == 404 ||
                request.status == 500 || request.status == 502) {
                switchingStation();
            } else {
                // 因为不需要切换站点, 所以报错需要提示出来
                if (options.isQHZD) {
                    showAlert(errorText, "提示信息");
                }
            }

        },

        complete: function() { // 回调函数执行后加载
            if (options.isloaddingrun && options.isloaddingstop) {
                loadding.stop();
            }

            // 回调函数
            if (options.completeMethod != null) {
                options.completeMethod();
            }
        }
    });
}

/**
 * 获取表单数据
 */
function getformdata() {
    // 将表单数据JSON对象化
    var dataJson = $("*[isSub=true]").serializeArray();

    // 将表单JSON对象转换成常规JSON对象
    dataJson = convertToJson(dataJson);

    // JSON对象转换成JSON字符串
    // dataJson = JSON.stringify(dataJson);
    // console.log(dataJson);
    return dataJson;
}

/**
 *    是否成功, 失败的提示信息由该函数统一处理
 *    @param 返回数据
 */
function IsSuccess(response, errorMethod, options) {
    var code = response.cljg[0].code;

    // 兼容处理 MP1B000000 也是成功返回标识
    if (code != params.code && code != "MP1B000000") {
        var message = response.cljg[0].message;

        // 过虑信息
        message = filterMessage(message);

        // 默认处理
        if (errorMethod == undefined) {
            showAlert(message, "提示信息");
        } else {
            angular.element($("body")).scope().$apply(function() {
                errorMethod(response);
            });
        }

        // 截取 code 前四位
        var code4 = code.substr(0, 4);

        // 应用异常与系统异常需要切换站点, 重新登录
        if (code4 == "MT1A" || code4 == "MT1S") {
            switchingStation();
        } else {
            // 不需要站点切换的回调函数
            if (options.errorMethod != null) {
                options.errorMethod();
            }

            // 因为不需要切换站点, 所以报错需要提示出来
            if (options.isQHZD) {
                showAlert(message, "提示信息");
            }
        }

        return false;

    } else {
        return true;
    }
}

/**
 * 过滤过失败信息中不需要显示的内容
 * @param message 失败信息的内容
 */
function filterMessage(message) {
    var param_index0 = message.indexOf("流水号");

    if (param_index0 >= 0) {
        message.replace("流水号", "");
    }

    // 相关参数出现的位置
    var param_index1 = message.indexOf("[相关参数");

    // 只有当相关参数出现的位置不在第首位才过滤相关参数
    if (param_index1 > 0) {
        message = message.substring(0, param_index1);
    }

    return message;
}

/**
 * 切换站点
 */
function switchingStation() {
    // 不需要切换站点
    if (!getLocalData("apiUrl") || params.urltmp == "") {
        console.log("不需要切换站点");

        return;
    }

    var apiUrl = JSON.parse(getLocalData("apiUrl"));

    // 正在使用超级用户设置的站点, 不需要进行切换站点
    if (apiUrl.testurl != "") {
        console.log("正在使用超级用户设置的站点, 不需要进行切换站点");

        return;
    }

    // 因为进入到该函数肯定是请求下一个站点, 所第一次调用函数肯定是从 2 开始
    params.count++;

    // 当循环请求站点列表中的最后一个站点时, 需要报错误提示信息, 其它的不需要报.
    var iserror = params.count == apiUrl.urllist.length;

    // 定义重新登录的方法
    var ss_login = {
        ptjy: function(method) {
            CloseAlert();

            if (getLocalData("ActivePTJYUser")) {

                console.log("切换站点 - 普通交易重新登录");

                var isloaddingstop = method == undefined ? true : false;

                var lastUrl = "ptjy/ptyw/login";
                var ptjyquest = JSON.parse(getLocalData("ActivePTJYUser"));

                ptjyquest = ptjyquest.head;

                ajaxPost(getApiUrl() + lastUrl, ptjyquest, function(response) {
                    if (method != undefined) {
                        method();
                    }
                }, null, {
                    isloaddingrun: false,
                    iserror: iserror,
                    isQHZD: true,
                    isLOGIN: true,
                    errorMethod: function() {

                        if (method != undefined) {
                            console.log("切换站点 - 服务器报业务错误, 需要普通交易或融资融券进行登录操作.");

                            ss_login.rzrq();
                        }

                    }
                });
            }
        },
        rzrq: function(method) {
            CloseAlert();

            if (getLocalData("ActiveRZRQUser")) {
                console.log("切换站点 - 融资融券重新登录");

                var lastUrl = "rzrq/ptyw/login";
                var rzrqquest = JSON.parse(getLocalData("ActiveRZRQUser"));

                rzrqquest = rzrqquest.head;

                ajaxPost(getApiUrl() + lastUrl, rzrqquest, function(response) {
                    if (method != undefined) {
                        method();
                    }
                }, null, {
                    isloaddingrun: false,
                    iserror: iserror,
                    isQHZD: true,
                    isLOGIN: true,
                    errorMethod: function() {

                        if (method != undefined) {
                            console.log("切换站点 - 服务器报业务错误, 需要普通交易或融资融券进行登录操作.");

                            ss_login.ptjy();
                        }

                    }
                });
            }
        },
        ptjyOrRzrq: function() {
            // 普通交易或融资融券登录

            if (params.ywlx == "ptjy") {
                // 融资融券重新登录
                ss_login.rzrq();
            } else if (params.ywlx == "rzrq") {
                // 普通交易重新登录
                ss_login.ptjy();
            }
        },
        login: function() {
            console.log("切换站点 - 登录界面处理");

            CloseAlert();

            var lastUrl = params.ywlx == "ptjy" ? "ptjy/ptyw/login" : "rzrq/ptyw/login";

            // 登录界面
            ajaxPost(getApiUrl() + lastUrl, getformdata(), function(response) {

                var userInfo = {};

                if (response.dlxx) {
                    //=======要从表单中提取出交易密码==============
                    userInfo["head"] = getformdata();
                    userInfo["body"] = response;
                    parseUserInfo(params.ywlx, userInfo, response.dlxx[0].khdm, IS_DBPHZ);
                }

                // 保存登录账号
                addKhbs(getformdata().khbz);

                // 如果是担保品划转需要的普通交易登录, 则不需要开始计时
                if (!IS_DBPHZ) {
                    // 调用 APP 锁屏计时器, 开始计时
                    timerAction(params.ywlx == "ptjy" ? params.ptjytimer : params.rzrqtimer, "start");
                }

                ss_login.ptjyOrRzrq();

            }, null, {
                isQHZD: true,
                completeMethod: function() {

                    $(".messageTips").remove();

                },
                errorMethod: function() {

                    console.log("切换站点 - 服务器报业务错误, 需要普通交易或融资融券进行登录操作.");

                    ss_login.ptjyOrRzrq();

                }
            });
        }
    }

    // 不需要切换站点
    if (apiUrl.testurl != "" || apiUrl.index == "" || apiUrl.urllist.length == 0 || params.count > apiUrl.urllist.length) {
        return;
    }

    // 如果当前站点是列表中最后一项, 则重新从 0 开始, 否则加 1
    apiUrl.index = apiUrl.index == (apiUrl.urllist.length - 1) ? 0 : parseInt(apiUrl.index) + 1;

    apiUrl.index = apiUrl.index + "";

    // 重新保存数据
    setLocalData("apiUrl", apiUrl);

    console.log("switchingStation => count: " + params.count);

    // 登录操作不需要重新登录
    if (params.urltmp.indexOf("login") > -1) {
        // 重新点击登录按钮
        // angular.element(document.getElementById("login-button")).scope().Login();

        showMessageTips("交易登录中, 请稍候...", null, 0);

        ss_login.login();

        return;
    }

    /** 切换站点后, 需要重新登录. 因为是重新登录(不同站点返回信息是相同的), 所以返回信息不需要重新保存 */

    // 普通交易重新登录与融资融券重新登录
    if (getLocalData("ActivePTJYUser") && getLocalData("ActiveRZRQUser")) {
        ss_login.ptjy(ss_login.rzrq);

        return;
    }

    // 普通交易重新登录
    ss_login.ptjy();

    // 融资融券重新登录
    ss_login.rzrq();

}


/**
 * 将表单对象转为json对象
 * @param formValues
 * @returns
 */
function convertToJson(formValues) {
    var result = {};

    for (var formValue, j = 0; j < formValues.length; j++) {
        formValue = formValues[j];
        var name = formValue.name;
        var value = formValue.value;

        if (name.indexOf('.') < 0) {
            result[name] = value;
            continue;
        } else {
            var simpleNames = name.split('.');

            // 构建命名空间
            var obj = result;
            for (var i = 0; i < simpleNames.length - 1; i++) {
                var simpleName = simpleNames[i];

                if (simpleName.indexOf('[') < 0) {
                    if (obj[simpleName] == null) {
                        obj[simpleName] = {};
                    }
                    obj = obj[simpleName];
                } else { // 数组
                    // 分隔
                    var arrNames = simpleName.split('[');
                    var arrName = arrNames[0];
                    var arrIndex = parseInt(arrNames[1]);
                    if (obj[arrName] == null) {
                        obj[arrName] = []; // new Array();
                    }
                    obj = obj[arrName];
                    multiChooseArray = result[arrName];
                    if (obj[arrIndex] == null) {
                        obj[arrIndex] = {}; // new Object();
                    }
                    obj = obj[arrIndex];
                }

            }

            if (obj[simpleNames[simpleNames.length - 1]]) {
                var temp = obj[simpleNames[simpleNames.length - 1]];
                obj[simpleNames[simpleNames.length - 1]] = temp;
            } else {
                obj[simpleNames[simpleNames.length - 1]] = value;
            }

        }
    }
    return result;
}


/*********************************************************************************************/
/********************************* 与 APP 交互的函数 start ***********************************/
/*********************************************************************************************/
/**
 *    显示键盘
 *    @param        id    触发显示键盘事件的文本框ID
 *    @param        type    键盘类型    1.纯数字键盘,2.带小数点的数字键盘,3.数字字母切换键盘,4.纯字母键盘,10.键盘精灵 ;
 */
function showKeyboard(id, type) {
    if (id == undefined) {
        console.log("文本输入框 id 不能为空!");
        return;
    }

    if ($('#' + id).length == 0) {
        console.log("文本输入框 id 不存在! id=" + id);
        return;
    }

    $("#" + id).focus();

    if (type == undefined) {
        console.log("键盘类型不存在!");
        hideKeyBoard();
        return;
    }

    var X = $('#' + id).offset().left;
    var Y = $('#' + id).offset().top;
    Y += $('#' + id).height(); // 加上文本框高度
    Y += 80; // 额外加 80 像素, 可以显示出下一个输入框或按钮

    // 是否是相同的 ID
    var sameid = id == params.id;

    params.id = id;

    if (params.id == "zqdm" || params.id == "hqzqdm" || params.id == "zrzqdm") {
        // 输入内容时,停止自动刷新
        order.isStopAutoQuery = true;

        $("#" + params.id).val("");

        // 隐藏股东账号
        // if( $("#holder").length > 0 )
        // {
        // 	$("#holder").hide();
        // }

        if (params.id == "zqdm") {
            $("#zqmc").text("");

            if (params.ywlx == "kfsjj") {
                clearJJJYForm(params.id);
            } else {
                clearBargainPageFullData("NoAjax");
            }
        } else if (params.id == "zrzqdm") {
            clearJJJYForm(params.id);
        } else if (params.id == "hqzqdm") {
            clearZQDMVolumeForm("请输入还券数量", "hq");
        }
    } else if (params.id == "price") {
        order.isMouseLeavePriceInput = false;
    }



    console.log("[" + params.id + "] [键盘类型:" + type + "] 当前文本框的坐标 X:" + X + " Y:" + Y);

    if (params.browser == 'android') {
        // 偏移量 ( 页面可见区域高度 - 输入框底部到页面顶部的高度 )
        params.topPyl = Y - (window.document.body.clientHeight / 2);
        // 系数 = 输入框底部到页面顶部的高度 / 页面可见区域高度
        Y = Y / window.document.body.clientHeight;

        // 低版本, 不需要上推
        if (params.lowVersion) {
            if (params.topPyl > 0 && !sameid) {
                $("body").css("margin-top", (-params.topPyl) + "px");
            } else {
                params.topPyl = 0;
            }

            Y = 0;
        }

        KDS_Native.showKeyBoard(type, Y);
    } else if (params.browser == 'ios') {
        location.href = "KDS_Native://showKeyBoard:" + type + ":" + Y;
    } else {
        // console.log("只能在IOS系统与Android系统显示自定义键盘");
    }

}

/**
 *    隐藏APP自定义键盘
 */
function hideKeyBoard() {
    try {
        if (params.browser == 'android') {
            KDS_Native.hideKeyBoard();
        } else if (params.browser == 'ios') {
            loadURL("KDS_Native://hideKeyBoard");
        }
    } catch (error) {
        console.error("系统不支持 hideKeyBoard 接口", error);
    }
}

/**
 *    自定义键盘回调函数    [与APP交互使用,函数名不能随意修改]
 *    @param param    键盘输入的值
 */
function fillInputContent(param) {
    if (param == "del") {
        var _value = $("#" + params.id).val();

        $("#" + params.id).val(_value.substring(0, _value.length - 1));
    } else {
        // 交易密码/资金密码/银行密码长度不能超过8位
        if ((params.id == "jymm" || params.id == "zjmm" || params.id == "yhmm") && $("#" + params.id).val().length >= 8) {

        } else {
            $("#" + params.id).val($("#" + params.id).val() + param);
        }
    }

}

/**
 * 关闭自定义键盘回调函数
 */
function closeKeyBoard() {
    // android 4.4 以下的手机
    if (params.lowVersion) {
        // 重置滚动条
        resetScroll();
    }
}

/**
 *    URL 跳转界面
 *    @param url    url地址
 *    @param hasRefresh    标识有无刷新按钮 0：显示，4：隐藏(占空间),8:隐藏(不占空间)
 *    @param direction    1：下一级界面；-1：返回上一级界面
 */
function JumpInterface(url, hasRefresh, direction) {

    console.log("[URL] " + url);

    // 未传第3个参数时默认为1
    direction = direction == undefined ? 1 : direction;

    if (!isNaN(hasRefresh)) {
        hasRefresh = parseInt(hasRefresh);
    } else {
        console.log("hasRefresh参数值不是数字，使用默认值 0 ");
        hasRefresh = 0;
    }

    if (!isNaN(direction)) {
        direction = parseInt(direction);
    } else {
        console.log("direction参数值不是数字，使用默认值 1 ");
        direction = 1;
    }


    if (params.browser == 'android') {
        KDS_Native.switchWebView(url, hasRefresh, direction);
    } else if (params.browser == 'ios') {
        // location.href="KDS_Native://switchWebView:"+url+":"+hasRefresh+":"+direction;
        loadURL("KDS_Native://switchWebView:" + url + ":" + hasRefresh + ":" + direction);
    } else {
        url = getfirsthref() + url;

        console.log("跳转地址：" + url);

        // 平级页面之间的跳转
        if (direction == 0)
            location.replace(url)
        else
            location.href = url;
    }
}

/**
 * Javascript语言
 * 通知iPhone UIWebView 加载url对应的资源
 * @param url
 */
function loadURL(url) {
    var iFrame;
    iFrame = document.createElement("iframe");
    iFrame.setAttribute("src", url);
    iFrame.setAttribute("style", "display:none;");
    iFrame.setAttribute("height", "0px");
    iFrame.setAttribute("width", "0px");
    iFrame.setAttribute("frameborder", "0");
    document.body.appendChild(iFrame);
    // 发起请求后这个iFrame就没用了，所以把它从dom上移除掉
    iFrame.parentNode.removeChild(iFrame);
    iFrame = null;
}

/**
 * 获取版本号
 */
function getVersion() {
    return params.version;
}

/**
 * 调用 APP 锁屏计时器
 * @param timerName 计时器名称
 * @param actionType 对计时器进行的操作包括 ( start: 开启计时 reset: 重置计时器同时开始计时 stop: 停止计时器 )
 */
function timerAction(timerName, actionType) {
    try {
        if (params.browser == "android") {
            KDS_Native.timerAction(timerName, actionType);
        } else if (params.browser == "ios") {
            location.href = "KDS_Native://timerAction:" + timerName + ":" + actionType;
        }
    } catch (error) {
        console.error("系统不支持 timerAction 接口", error);
    }

}

/**
 *设置本地存储数据
 * @param key   键名
 * @param value 键值
 * @param from  来源 0: android 1: ios
 */
function setLocalData(key, value, from) {
    value = typeof(value) == "string" ? value : JSON.stringify(value);

    window.localStorage.setItem(key, value);

    // 非 APP 调用该接口时, 需要把特殊键值保存到APP里去.
    if (from == undefined && $.inArray(key, params.appKey) > -1) {
        saveOrUpdateLocalData(key, value);
    }
}

/**
 * 保存或修改 APP 里面的本地存储; 当 value 值为空字符串时, 则删除该键
 * @param key   键
 * @param value 值
 */
function saveOrUpdateLocalData(key, value) {
    if (params.browser == "android") {
        KDS_Native.saveOrUpdateLocalData(key, value);
    }
    if (params["zqgs"] == ZQGS_TONGXIN) //暂时只有同信才加
    {
        if (params.browser == "ios") {
            loadURL("KDS_Native://SaveOrUpdateLocalData:" + key + ":" + value);
        }
    }
}

/**
 * 设置行情刷新时间
 * @parma time 时间 (单位: 秒)
 */
function setHqTime(time) {
    time = typeof(time) == "number" ? time : parseInt(time);

    setLocalData("hqtime", time);

    params['sxhqpl'] = time * 1000;
}

/**
 * 重置滚动条
 */
function resetScroll() {
    if (params.topPyl > 0) {
        $("body").css("margin-top", "0px");

        params.topPyl = 0;
    }
}

/**
 * 设置 ajax 请求超时时间
 * param time 时间 单位: 毫毛
 */
function setAjaxTimeOut(time) {
    setLocalData("ajaxtimeout", time + "");
}

/**
 * 设置 App 版本号
 * param version 版本号
 */
function setAppVersion(version) {
    setLocalData("appversion", version + "");
}
/*********************************************************************************************/
/********************************* 与 APP 交互的函数 end *************************************/
/*********************************************************************************************/

/**
 * 获取 App 版本号
 */
function getAppVersion() {
    if (getLocalData("appversion")) {
        return getLocalData("appversion");
    }
    // 如果 App 没有设置版本号, 则使用该默认版本号
    else {
        return "3.0.3";
    }
}
/**
 * 获取行情刷新时间
 */
function getHqTime() {
    if (getLocalData("hqtime")) {
        return parseInt(getLocalData("hqtime")) * 1000;
    }

    return 10 * 1000;
}

/*============================================
 函数功能:       去除字符串中的空格回车
 传入参数:         str:原字符串
 =============================================*/
function trim(str) {
    return str.replace(/(^\s*)|(\s*$)/g, '');
}

/*============================================
 函数功能:       获取本地存储数据
 传入参数:         key:键值
 =============================================*/
function getLocalData(key) {
    // 如果是在 App 里保存的数据, 且版本号要大于 3.0.3, 则从 App 里面获取
    if (params.browser == "android" && $.inArray (key, params.appKey) > -1) {
        // 优选使用 APP 内保存的数据
        try {
            var value = KDS_Native.getLocalData(key);
        } catch (error) {
            console.log("原生 APP 没有定义 getLocalData 函数");
        }
        // 当 APP 返回的数据为空时, 使用本地存储里的数据
        if (value == undefined || value == "") {
            if (window.localStorage.getItem(key)) {
                return trim(window.localStorage[key]);
            }
            return null;
        }
        return value;
    } else if (window.localStorage.getItem(key)) {
        // value = JSON.parse(storage.getItem(key));
        return trim(window.localStorage[key]);
    }

    return null;
}
/*============================================
 函数功能:       清除本地存储数据
 传入参数:         key:键值
 =============================================*/
function removeLocalData(key) {
    window.localStorage.removeItem(key);
}
/*============================================
 函数功能:       清空本地存储数据
 =============================================*/
function clearLocalData() {
    window.localStorage.clear();
}

//===========================================================
//函数功能:       清除登录信息
//===========================================================
function ClearLoginInfo() {
    // alert("ClearLoginInfo");

    removeLocalData("page");
    removeLocalData("zqdm");

    // 融资融券模块界面登录超时,则清除融资融券登录账号信息
    if (params.ywlx == "rzrq") {
        removeLocalData('lockRZRQUser');
        removeLocalData("ActiveRZRQUser");

        // 非多账号登录-----更新用户列表
        if (getLocalData("rzrqMultiAccountLogin") == undefined) {
            Account = JSON.parse(getLocalData("rzrqAccount"));
        }

    } // 普通业务界面登录超时,则清除普通交易登录账号信息
    else if (params.ywlx == "ptjy") {
        removeLocalData("ActivePTJYUser");
        removeLocalData('lockPTJYUser');

        if (getLocalData("ptjyMultiAccountLogin") == undefined) {
            Account = JSON.parse(getLocalData("ptjyAccount"));
        }
    }
}
//===========================================================
//函数功能:         跳转到登录页
//===========================================================
function JumpHeaderPage() {
    // var curURL=document.location.href.slice(document.location.href.lastIndexOf("/")+1);

    // 如果登录超时时停留在融资融券模块界面,则跳转到融资融券首页
    if (params.ywlx == "rzrq") {
        timerAction(params.rzrqtimer, "stop");
        JumpInterface(params.viewKey.KDS_RZRQHeader, 4, -100);

    } // 如果登录超时时停留在普通业务模块界面,则跳转到普通业务首页
    else if (params.ywlx == "ptjy") {
        timerAction(params.ptjytimer, "stop");
        JumpInterface(params.viewKey.KDS_PTJYHeader, 4, -100);
    }

}
//===========================================================
//函数功能:        注销用户登录信息
//===========================================================
function Logout() {
    ClearLoginInfo();
    JumpHeaderPage();
}
//===========================================================
//函数功能:        多账号登录判断
//===========================================================
function MultiAccountLogin() {
    //==========设置多账号跳转标记=============
    setLocalData("MultiAccountLogin", "true");
    Logout();
}

/*============================================
 函数功能:         是否登录
 =============================================*/
function IsLogin() {

    // 如果登录的是融资融券模块
    if (params.ywlx == "rzrq") {

        if (getLocalData("ActiveRZRQUser") == undefined) {
            Logout();
            return false;
        }
    } // 如果登录的是普通业务模块模块
    else if (params.ywlx == "ptjy") {
        //==========判断用户是否登录===========
        if (getLocalData("ActivePTJYUser") == undefined) {
            Logout();
            return false;
        }

    }

    return true;
}
/*============================================
 函数功能:         记录复选框的设置状态
 =============================================*/
function RecordCheckBox(obj) {
    if ($(obj).attr("checked") == undefined) {
        setLocalData(ID, true);
        $(obj).attr({
            "checked": true
        });
    } else {
        removeLocalData(ID);
        $(obj).removeAttr("checked");
    }
}
/*============================================
 函数功能:         设置复选框状态
 =============================================*/
function setCheckBox(ID) {
    if (getLocalData(ID)) {
        $("#" + ID).attr({
            "checked": true
        });
    } else {
        $("#" + ID).removeAttr("checked");
    }
}

/*============================================
 函数功能:         设置留痕信息
 =============================================*/
function setMarkInfo(obj) {
    setLocalData("lhxx", obj);
}

/*============================================
 函数功能:         设置留痕信息
 =============================================*/
function getMarkInfo() {
    var lhxx = getLocalData("lhxx");
    return lhxx == undefined || lhxx == null || lhxx.length == 0 ? "aaaaaaa" : lhxx;
}

/*=====================================================
 函数功能: 添加自选股
 入参说明: stockName 股票名称
 stockCode 股票代码
 marketId  市场代码
 =====================================================*/
function addUserStock(stockName, stockCode, marketId) {
    console.log("调用添加自选股函数 [stockName=" + stockName + ", stockCode=" + stockCode + ", marketId=" + marketId + "]");

    if (params.browser == "android") {
        KDS_Native.addUserStock(stockName, stockCode, marketId)
    } else if (params.browser == "ios") {
        location.href = "KDS_Native://addUserStock:" + stockName + ":" + stockCode + ":" + marketId;
    }
}

/*============================================
 函数功能：对返回数据中的列表数据进行非空处理
 =============================================*/
function formatResponseData(response, str) {
    // 判断入参是对象还是集合, 然后不同的处理
    var cxlb = response.toString() == "[object Object]" ? response.cxlb : toString.apply(response) == "[object Array]" ? response : [];
    str = str == undefined ? "--" : str;

    for (var i = 0, len = cxlb.length; i < len; i++) {
        for (var j = 0, len2 = cxlb[i].length; j < len2; j++) {
            cxlb[i][j] = cxlb[i][j] == undefined || cxlb[i][j] == null || cxlb[i][j].trim() == "" ? str : cxlb[i][j];
        }
    }
}

/*============================================
 函数功能：对返回的新股列表数据进行非空处理
 =============================================*/
function formatNewStockData(response, str, filter) {
    // 判断入参是对象还是集合, 然后不同的处理
    var cxlb = response.toString() == "[object Object]" ? response.cxlb : toString.apply(response) == "[object Array]" ? response : [];
    str = str == undefined ? "--" : str;
    filter = filter == undefined ? [] : filter;
    var iscontinue = false;

    for (var i in cxlb) {
        for (var j in cxlb[i]) {
            iscontinue = false;

            // 过滤一些不需要非空或 0 处理字段
            for (var k in filter) {
                if (j == filter[k]) {
                    iscontinue = true;
                    break;
                }
            }

            if (iscontinue) continue;

            cxlb[i][j] = cxlb[i][j] == undefined || cxlb[i][j] == null || cxlb[i][j].trim() == "" || cxlb[i][j].trim() == "0" || cxlb[i][j].trim() == "0.00" ? str : cxlb[i][j];
        }
    }
}


/*============================================
 函数功能：设置是否注册
 入参说明：手机号码
 =============================================*/
function setIsRegister(phone) {
    setLocalData("cellPhoneNumber", phone);

    // loadding.stop();
}

/*============================================
 函数功能：获取是否注册
 =============================================*/
function getIsRegister() {
    var cellPhoneNumber = getLocalData("cellPhoneNumber");

    return cellPhoneNumber == undefined || cellPhoneNumber == null || cellPhoneNumber.length == 0 ? false : true;
}

/*============================================
 函数功能：显示注册界面
 =============================================*/
function showRegisterView() {
    if (params.browser == "android") {
        KDS_Native.ShowRegisterView()
    } else if (params.browser == "ios") {
        location.href = "KDS_Native://ShowRegisterView";
    }
}

/*=========================================
 函数功能：获取当前URL地址前半部分
 =========================================*/
function getfirsthref(len) {
    len = len == undefined || len == null ? 5 : len;

    var _url = window.location.href;

    var _index = _url.indexOf("view/");
    _url = _url.substring(0, _index + len);

    return _url;
}

/*=========================================
 函数功能：获取当前URL地址后半部分
 =========================================*/
function getlasthref() {
    var _url = window.location.href;

    var _index = _url.indexOf("view/");
    _url = _url.substring(_index + 5);

    return _url;
}
/*=========================================
 函数功能：获取浏览器类型
 =========================================*/
function getBrowser() {
    var type = "pc"
    var ua = navigator.userAgent.toLowerCase();

    if (ua.indexOf('android') > -1) {
        type = "android"

        var start_index = ua.indexOf('android');

        var version = ua.substring(start_index, start_index + 12);

        version = version.replace("/", " ");

        // 低于 android 4.4 版本
        if (version < "android 4.4") {
            params.lowVersion = true;

            updateClass("common.css", ".modal-dialog", function(cssRule) {
                cssRule.style.top = "2%";
                cssRule.style.marginTop = "0px";
            });
        }

    } else if (ua.indexOf('iphone') > -1 || ua.indexOf('ipad') > -1) {
        type = "ios";
    }

    return type;
}

/**
 *    消除 inpunt 的属性 readonly
 */
function clearReadonly() {
    if (params.browser == 'android') {
        // $("input").each(function(){

        // 	// 隐藏表单域则跳过
        // 	if($(this).attr("type") != "hidden" && $(this).attr("type") != "checkbox")
        // 	{
        // 		// 显示系统键盘
        // 		if( $(this).attr("data-syskeyboard") == undefined )
        // 		{
        // 			// 删除只读属性
        // 			$(this).removeAttr("readonly");
        // 			// 删除自定义键盘事件
        // 			$(this).removeAttr("onClick");
        // 			// 设置修改文本框属性, 显示系统数字键盘
        // 			$(this).attr("type", "number");
        // 		}
        // 		// 显示自定义键盘
        // 		else
        // 		{
        // 			$(this).attr("readonly", "readonly");
        // 		}
        // 	}
        // });

        $("input[type=text],input[type=password]").attr("readonly", "readonly");

    } else if (params.browser == 'ios') {
        $("input[type=text],input[type=password]").attr("readonly", "readonly");
    } else {
        $("input").removeAttr("readonly");
    }
}

/*========================================
 函数功能:    快捷跳转
 传入参数:   viewKey:跳转界面
 ========================================*/
function QuickJump(viewKey) {
    //=====清除快捷跳转判断标志位=====
    removeLocalData("quickJump");

    if (viewKey == "KDS_SM_WTJY") { // 委托交易

        JumpInterface(params.viewKey.KDS_SM_WTJY, 8, -100);
    } else if (viewKey == "KDS_SM_ZCCX") { // 资产查询

        JumpInterface(params.viewKey.KDS_SM_ZCCX, 8, -100);
    } else if (viewKey == "KDS_Buy") { // 买入
        window.localStorage.setItem("page", "买入");
        JumpInterface(params.viewKey.KDS_Buy, 8, -100);
    } else if (viewKey == "KDS_Sell") { // 卖出
        window.localStorage.setItem("page", "卖出");
        JumpInterface(params.viewKey.KDS_Sell, 8, -100);
    } else if (viewKey == "KDS_CheDan") { // 撤单
        window.localStorage.setItem("page", "撤单");
        JumpInterface(params.viewKey.KDS_CheDan, 8, -100);
    } else if (viewKey == "KDS_Query") { // 查询
        window.localStorage.setItem("page", "查询");
        JumpInterface(params.viewKey.KDS_Query, 0, -100);
    } else if (viewKey == "KDS_SM_YZZZ") { // 银证转账
        //window.localStorage.setItem("page","银证转账");
        JumpInterface(params.viewKey.KDS_SM_YZZZ, 0, -100);
    } else if (viewKey == "KDS_SM_XGSG") { // 新股申购
        //window.localStorage.setItem("page","新股申购");
        JumpInterface(params.viewKey.KDS_SM_XGSG, 0, -100);
    } else if (viewKey == "KDS_SM_CCQuery") { // 持仓查询
        window.localStorage.setItem("page", "持仓");
        JumpInterface(params.viewKey.KDS_SM_CCQuery, 8, -100);
    } else if (viewKey == "KDS_SM_KFSJJ") { // 开放式基金
        //window.localStorage.setItem("page","开放式基金");
        JumpInterface(params.viewKey.KDS_SM_KFSJJ, 8, -100);
    } //=================担保品划转==========
    else if (viewKey == "KDS_RZRQ_DBPHZ") {
        JumpInterface(params.viewKey.KDS_RZRQ_DBPHZ, 8, 0);
    } else if (viewKey == "KDS_Bind_ZJZH") { // 资金账号绑定
        var ActiveUse = JSON.parse(getLocalData("ActivePTJYUserTmp"));

        if (params.browser == "android") {

            var zjzh = ActiveUse.body.dlxx.length == 0 || ActiveUse.body.dlxx[0].zjzh == undefined ? "" : ActiveUse.body.dlxx[0].zjzh;
            console.log(ActiveUse.body.dlxx[0].zjzh);

            KDS_Native.backZjzhBinde(zjzh);
        } else if (getBrowser() == "ios") {
            loadURL("KDS_Native://backZjzhBinde:" + ActiveUse.body.dlxx[0].zjzh);
        }

        // 删除登录信息的临时数据
        removeLocalData("ActivePTJYUserTmp");
    }
}

/**
 *    快捷跳转页面    [与APP交互使用,函数名与viewKey值不能随意修改]
 *    @param viewKey    目的页面对应键
 *    @param zqdm    买入卖出页面需要传递股票代码
 */
function jumpToView(viewKey, zqdm) {

    if (viewKey == "") {
        removeLocalData("quickJump");
        return;
    } else {
        // 设置快捷跳转标志位
        setLocalData("quickJump", viewKey);
    }


    if (viewKey == "KDS_Buy" || viewKey == "KDS_Sell") {
        window.localStorage.setItem("zqdm", zqdm);
    }

    // 如果该页面是快捷跳转目标页面, 则删除快捷跳转标志位
    if (params['viewKey'][viewKey] == getlasthref()) {
        removeLocalData("quickJump");
    }

    //====================判断是否已经登录,如果已经登录,直接跳转==================
    //=========如果未登录,登录验证通过后,不经过交易主页直接跳转到点击的快捷页面===
    // if(IsLogin())
    // {
    // 	 QuickJump(viewKey);
    // }
}

//设置交易服务器地址	[与APP交互使用,函数名不能随意修改]
function setApiUrl(apiUrl) {
    setLocalData("apiUrl", apiUrl);

    // 普通交易
    if (getlasthref().indexOf("ptjy/") >= 0) {
        if (getlasthref() != params.viewKey.KDS_PTJYHeader) {
            JumpInterface(params.viewKey.KDS_PTJYHeader, 4, -100);
        }
    }

    // 融资融券
    else if (getlasthref().indexOf("rzrq/") >= 0) {
        if (getlasthref() != params.viewKey.KDS_RZRQHeader) {
            JumpInterface(params.viewKey.KDS_RZRQHeader, 4, -100);
        }
    }

    // 清除登录信息
    ClearLoginInfo();
}

// 获取交易服务器地址	[与APP交互使用,函数名不能随意修改]
function getApiUrl() {
    // APP 如果没有设置交易服务器地址, 则给 APP 返回空字符串
    if (!getLocalData("apiUrl")) {
        // 在 PC 端可以使用默认定义的 URL 地址
        if (params.browser == "pc") {
            return params.apiUrl;
        }

        return "";
    }

    var apiUrl = JSON.parse(getLocalData("apiUrl"));

    // 超级用户里面设置的交易服务器测试地址
    if (apiUrl.testurl != "") {
        console.log("正在使用超级用户里面设置的交易服务器测试地址");
        return apiUrl.testurl;
    }

    // 站点列表无数据
    if (apiUrl.index == "" || apiUrl.urllist.length == 0) {
        console.log("站点列表无数据");
        return "";
    }

    // 安卓需要调用函数才能传入值
    if (params.browser == 'android') {
        KDS_Native.setTradeUrl(apiUrl.urllist[apiUrl.index]);
    }

    // 从站点列表中选取最优的站点
    return apiUrl.urllist[apiUrl.index];
}

// 设置请求超时时间
function setTimeOut(timeOut) {
    console.log("设置系统交易超时时间: " + timeOut);
    setLocalData("timeOut", timeOut);
}

// 设置新股申购地址
function setApiUrlNews(apiUrlNews) {
    setLocalData("apiUrlNews", apiUrlNews);
}

// 获取新股申购地址	[与APP交互使用,函数名不能随意修改]
function getApiUrlNews() {
    // APP 如果没有设置新股申购地址, 则给 APP 返回空字符串
    // if( params.browser != "pc")
    // {
    // 	return getLocalData("apiUrlNews") != null ? getLocalData("apiUrlNews") : "";
    // }

    return getLocalData("apiUrlNews") != null ? getLocalData("apiUrlNews") : params.apiUrlNews;
}

//获取请求超时时间
function getTimeOut() {
    var _timeout = getLocalData("timeOut");

    if (_timeout == null || _timeout == undefined) {
        console.log("系统交易超时时间本地存储不存在");
    }

    return _timeout != null ? parseInt(getLocalData("timeOut")) : params.timeOut;
}

/**
 * 获取 ajax 请求超时时间
 */
function getAjaxTimeOut() {
    var _timeout = getLocalData("ajaxtimeout");

    if (_timeout == null || _timeout == undefined) {
        // 默认一分钟
        return 1000 * 45;
    }

    return parseInt(getLocalData("ajaxtimeout"));
}

/*========================================
 函数功能：获取登录账号	[与APP交互使用,函数名不能随意修改]
 没有登录则返回空字符串
 =========================================*/
function getLoginAccount() {
    var khbs = "";

    if (getLocalData("ActivePTJYUser")) {
        //登录时入参
        var ActiveUse = JSON.parse(getLocalData("ActivePTJYUser"));
        // 登录后返回的资金账号
        khbs = ActiveUse['body'].dlxx[0].zjzh;
    }

    // 回调 android 函数, 把登录账号传过去.	空字符串表示没有登录
    if (getBrowser() == "android") {
        KDS_Native.onLoginAccount(khbs)
    }

    return khbs;
}

/*========================================
 函数功能：传递用户普通交易登录信息给原生"我的界面使用"	[与APP交互使用,函数名不能随意修改]
 交易登录后，会将登录参数传递给原生(json格式:{name:"凯特琳",tel:"5252522"})
 万和版本用
 =========================================*/
function onLoginTrade(array) {
    if (!(isAppointedCompony(ZQGS_WANHE)
        || isAppointedCompony(ZQGS_HUAXI)
        )) {
        return;
    }
    if ("ptjy" != params.ywlx) {
        return;
    }
    if (array.length == 0) {
        return;
    }
    var json = {
        name: array[0].khxm
    };
    json = JSON.stringify(json);
    var browser = params.browser;
    try {
        if ('android' == browser) {
            KDS_Native.onLoginTrade(json);
        } else if ('ios' == browser) {
            loadURL("KDS_Native://onLoginTrade:" + json);
        }
    } catch (error) {
        console.log(error.name, error.message);
        console.log("原生代码没有'onLoginTrade'方法");
    }
}

/*====================================
 函数功能：自助开户	[与APP交互使用,函数名不能随意修改]
 =====================================*/
function selfserviceAccount() {
    if (params.browser == 'android') {
        KDS_Native.selfserviceAccount();
    } else if (params.browser == 'ios') {
        location.href = "KDS_Native://selfserviceAccount";
    } else {
        console.log("只能在IOS系统与Android系统下点击自助开户");
    }
}
/*==================================================================
 函数功能：          显示登录锁定对话框
 传入参数:              ywlx:业务类型
 ==================================================================*/
function showLockDialog(ywlx) {
    // 在未登录页面下不需要弹出锁定对话框
    if (!haveLogged()) {
        return;
    }

    if ($("#TimeOut").length == 0) {

        $(document.body).append(TimeOut);

        //  如果未登录,不弹出登录超时锁定
        if (params.ywlx == "rzrq" && getLocalData('ActiveRZRQUser')) {
            $("#TimeOut #title").text("信用账号");
            $("#TimeOut #khbz").text(JSON.parse(getLocalData('ActiveRZRQUser'))["head"]['khbz']);
        } else if ((params.ywlx == "ptjy" || params.ywlx == "kfsjj") && getLocalData('ActivePTJYUser')) {
            $("#TimeOut #title").text("普通账号");
            if (isAppointedCompony(ZQGS_TONGXIN)) { //西藏同信读取返回的完整账号
                $("#TimeOut #khbz").text(JSON.parse(getLocalData('ActivePTJYUser'))["body"]['dlxx'][0]['zjzh']);
            } else {
                $("#TimeOut #khbz").text(JSON.parse(getLocalData('ActivePTJYUser'))["head"]['khbz']);
            }
        } else {
            $("#TimeOut").remove();
            return;
        }

        // 使提示框居中显示
        moveToCenter("dialog");

    }
}

/**
 * 已经登录
 */
function haveLogged(step) {
    var lasthref = getlasthref();

    if (
        lasthref.indexOf("ptjy_header.html") > 0 ||
        lasthref.indexOf("ptjy_login.html") > 0 ||
        lasthref.indexOf("rzrq_header.html") > 0 ||
        lasthref.indexOf("rzrq_login.html") > 0
    ) {
        return false;
    } else {
        return true;
    }
}

/*==================================================================
 函数功能：   登录超时处理函数	[与APP交互使用,函数名不能随意修改]
 入参说明：			ywlx 业务类型 ( ptjy: 普通交易; rzrq: 融资融券 )
 ==================================================================*/
function TimeoutHandler(ywlx) {
    console.log("调用 TimeoutHandler(ywlx) 函数!");

    ywlx = ywlx == undefined ? "" : ywlx;

    // 在未登录页面下不需要弹出锁定对话框
    if (!haveLogged()) {
        return;
    }

    if (params.ywlx == "") {
        showMessageTips("登录超时锁屏没有传入业务类型");
    } else if (params.ywlx == "ptjy" || params.ywlx == "kfsjj") {
        if (!getLocalData('ActivePTJYUser')) {
            showMessageTips("普通交易的当前用户信息不存在");
        }
    } else if (params.ywlx == "rzrq") {
        if (!getLocalData('ActiveRZRQUser')) {
            showMessageTips("融资融券的当前用户信息不存在");
        }
    }

    if ((params.ywlx == "ptjy" || params.ywlx == "kfsjj") && getLocalData('ActivePTJYUser')) // 普通交易
    {
        setLocalData("PTJYTimeOut", "true");

        timerAction(params.ptjytimer, "stop");
    } else if (params.ywlx == "rzrq" && getLocalData('ActiveRZRQUser')) // 融资融券
    {
        setLocalData("RZRQTimeOut", "true");

        timerAction(params.rzrqtimer, "stop");
    } else {
        return;
    }

    showLockDialog(ywlx);
}
/*=======================================================
 函数功能：保存日志到本地数据库
 =======================================================*/
function saveLog(str) {
    var db = window.openDatabase("web", "1.1", "log", 1024 * 1024);

    // 创建或打开数据库失败
    if (!db) {
        return;
    }

    // 创建表
    db.transaction(function(tx) {
        tx.executeSql("CREATE TABLE if not exists log (createtime TEXT, content TEXT)");
    });

    // 插入记录
    db.transaction(function(tx) {
        tx.executeSql("INSERT INTO log (createtime, content) values(?, ?)", [new Date().Format("yyyyMMdd hh:mm:ss"), str], null, null);
    });
}

/*=======================================================
 函数功能：查询本地数据库里的日志信息
 =======================================================*/
function selectLog(sql) {
    var db = window.openDatabase("web", "1.1", "log", 1024 * 1024);
    // 创建或打开数据库失败
    if (!db) {
        return;
    }

    // 查询数据
    db.transaction(function(tx) {

        if (sql == undefined || sql == "") {
            sql = "SELECT * FROM log";
        }

        tx.executeSql(sql, [], function(tx, result) {
                for (var i = 0; i < result.rows.length; i++) {
                    console.warn(result.rows.item(i)['content']);
                }
            },
            function() {
                console.error("查询失败! 原因：1、没有创建表; 2、表中无数据");
            });
    });
}

/*=======================================================
 函数功能：清空数据库表数据
 =======================================================*/
function clearLog() {
    var db = window.openDatabase("web", "1.1", "log", 1024 * 1024);
    // 创建或打开数据库失败
    if (!db) {
        return;
    }

    db.transaction(function(tx) {
        tx.executeSql("DROP TABLE log");
    });

}

/* 调用示例
 var now = new Date();
 now.addMonths(-1);//加减日期操作
 console.log(now.Format("yyyyMMdd"));
 */
// 时间日期格式化
Date.prototype.Format = function(fmt) {
    //author: meizz
    var o = {
        "M+": this.getMonth() + 1, //月份
        "d+": this.getDate(), //日
        "h+": this.getHours(), //小时
        "m+": this.getMinutes(), //分
        "s+": this.getSeconds(), //秒
        "q+": Math.floor((this.getMonth() + 3) / 3), //季度
        "S": this.getMilliseconds() //毫秒
    };
    if (/(y+)/.test(fmt))
        fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
        if (new RegExp("(" + k + ")").test(fmt))
            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));

    return fmt;
}

// 加减天数
Date.prototype.addDays = function(d) {
    this.setDate(this.getDate() + d);
    return this;
};

// 加减星期
Date.prototype.addWeeks = function(w) {
    this.addDays(w * 7);
    return this;
};

// 加减月份
Date.prototype.addMonths = function(m) {
    var d = this.getDate();
    this.setMonth(this.getMonth() + m);

    if (this.getDate() < d)
        this.setDate(0);
    return this;
};

// 加减年份
Date.prototype.addYears = function(y) {
    var m = this.getMonth();
    this.setFullYear(this.getFullYear() + y);

    if (m < this.getMonth()) {
        this.setDate(0);
    }
    return this;
};

/*====================================================
 函数功能：模拟APP显示提示信息
 函数入参：obj	显示文字信息
 top 距离顶部的位置(百分比,可不传)
 time 设置时间, 0 永不隐藏
 ====================================================*/
function showMessageTips(obj, top, time) {
    top = top == null ? undefined : top;

    time = time == undefined ? 1000 * 3 : time;

    if ($(".messageTips").length > 0) {
        $(".messageTips").remove();
    }

    $("body").append('<div class="messageTips"><div>' + obj + '</div></div>');

    var left = (document.body.clientWidth - $(".messageTips").width()) / 2;

    $(".messageTips").css("left", left + "px");

    // 设置 top 距离时
    if (top != undefined) {
        $(".messageTips").css("top", top + "%");
    }

    if (time != 0) {
        setTimeout(function() {
            $(".messageTips").remove()
        }, time); //1000为1秒钟,设置为1分钟。
    }
}

/*================================================
 函数功能：加减
 入参说明：id	控件ID
 type 类型,加(plus)与减(minus)	默认加
 step 步长,默认1
 fixed	保留小数点位数 默认0
 =================================================*/
function plusMinus(id, type, step, fixed) {
    if (id == undefined || id == null) {
        showMessageTips("plusMinus 函数未传入ID");
        return;
    }

    step = step == undefined || step == null ? 1 : step;
    fixed = fixed == undefined || fixed == null ? 0 : fixed;
    type = type == undefined || type == null ? "plus" : type;

    var price = $("#" + id).val() || 0;

    if (type == "plus") {
        $("#" + id).val(Inc(price, step, fixed));
    } else if (type == "minus") {
        $("#" + id).val(Dec(price, step, fixed));
    }
}

/*====================================================================
 函数功能：                动态创建angular节点
 入参说明：$scope				  angular 的作用域
 $compile 			  angular 的编译参数
 node                节点
 nodeName        动态加载内容对象名
 modalValue		  动态加载内容
 ====================================================================*/
function dynGenerateNode($scope, $compile, node, nodeName, modalValue) {

    var template = angular.element(node);

    mobileDialogElement = $compile(template)($scope);

    //==================动态创建模态框=========================
    angular.element(document.body).append(mobileDialogElement);

    if (nodeName) {
        angular.element($("body")).scope().$apply(function() {

            $scope[nodeName] = modalValue;

        });
    }

}

/*=================================================
 函数功能：创建模态框
 入参说明：$scope				angular 的作用域
 $compile 			angular 的编译参数
 modal 				模态框需要显示内容对象
 FirstBtnHide	隐藏第一个按钮 (取消按钮)
 ==================================================*/
function create_modal($scope, $compile, modal, FirstBtnHide) {
    $scope.modal = modal;

    var template = angular.element(Modal);

    mobileDialogElement = $compile(template)($scope);

    //==================动态创建模态框=========================
    angular.element(document.body).append(mobileDialogElement);

    if (FirstBtnHide != undefined && FirstBtnHide != null && FirstBtnHide) {
        // 隐藏取消按钮
        $(".modal-footer > .btn-default").hide();
        $(".modal-footer > .btn-ensure").css("width", "70%");
    }

    return false;
}

/*=================================
 函数功能:  移除模态框
 =================================*/
function CloseModal() {
    // 有些模态框中有输入框,关闭模态框时关闭自定义键盘
    hideKeyBoard();

    // 判断模态框节点是否存在
    if (mobileDialogElement) {
        mobileDialogElement.remove();
    }
}
/*==================================================
 函数功能：格式化字符串日期
 入参说明：data   字符串日期
 format 格式
 ===================================================*/
function formatDate(date, format) {
    if (date == undefined || date == null || date == "") return;

    format = format == undefined || format == null ? "yyyyMMdd" : format;

    date = date.split("");
    format = format.split("");

    var newdate = [];
    var item = "";

    for (var key in format) {
        if (key > date.length - 1) break;

        if (!(format[key] == "y" || format[key] == "M" || format[key] == "d" || format[key] == "H" || format[key] == "h" || format[key] == "m" || format[key] == "s")) {
            date.splice(key, 0, format[key]);
        }

        newdate[key] = date[key];
    }

    // 数组日期转为字符串
    newdate = newdate.join("");

    return newdate;
}

/**
 * 修改文件样式
 * @param fileName  文件名称
 * @param className 样式名称
 * @param method    回调函数, 在回调函数内修改样式
 */
function updateClass(fileName, className, method) {
    var styleSheet = null,
        cssRule = null;

    for (var i = 0, len = document.styleSheets.length; i < len; i++) {
        if (document.styleSheets[i].href != null && document.styleSheets[i].href.indexOf(fileName) >= 0) {
            styleSheet = document.styleSheets[i];
            break;
        }
    }

    if (styleSheet == null) {
        return;
    }

    for (var i = 0, len = styleSheet.cssRules.length; i < len; i++) {
        if (styleSheet.cssRules[i].selectorText && styleSheet.cssRules[i].selectorText.indexOf(className) >= 0) {
            cssRule = styleSheet.cssRules[i];

            method(cssRule);
            return;
        }
    }
}

/*=================================================
 函数功能：点击页面非文本输入框区域关闭软键盘
 ==================================================*/
function CloseKeyBoard() {
    $("body input:not(:text,:password)").click(function() {

        hideKeyBoard();

    })
}

/** 营业部本地缓存key*/
const SALE_DEPARTMENT_INFO_KEY = "saleDepartmentInfoKey";
/**
 *  原生传递营业部代码
 * @param value (数据格式：[{"yybdm":"9527", "yybmc":"深圳中山路营业部"}])
 */
function initSaleInfo(value) {
    setLocalData(SALE_DEPARTMENT_INFO_KEY, value)
}

// 重置超时计数变量
function ResetTimeOutCounter() {
    if (params.ywlx == "rzrq") {
        // isRZRQTiming = 0;
        // 调用 APP 锁屏计时器, 开始计时
        timerAction(params.rzrqtimer, "reset");
    } else if (params.ywlx == "kfsjj") {
        timerAction(params.ptjytimer, "reset");
    } else if (window.location.href.indexOf("ptjy") > 0) {
        // isPTJYTiming = 0;
        // 调用 APP 锁屏计时器, 开始计时
        timerAction(params.ptjytimer, "reset");
    }
}

// 只要发生屏幕触摸,鼠标移动事件,就清空超时计数变量
document.addEventListener("touchstart", function() {

    ResetTimeOutCounter();

}, false);

document.addEventListener("mousemove", function() {

    ResetTimeOutCounter();

}, false);

//======为了禁止android ios弹出系统键盘,必须将input文本,密码输入框的属性设置为只读
clearReadonly();

// RemoveIOSHoverEvent();
document.write("<script src=" + (getfirsthref(0) + "js/fastclick.js") + "><" + '/' + "script>");

$(window).load(function() {
    FastClick.attach(document.body);
});
