/**
 * 登录
 * $Date: $
 * $Revision: $
 * $Author: $
 */

/************************** 定义全局变量 ********************************/
var LD_ZHLB_NAME = "";	// 本地数据 - 账户列表名称
var LD_JZZH_NAME = "";	// 本地数据 - 记住账户名称
var LD_LSZH_LSIT = [];	// 本地数据 - 历史登录账号列表数据
var IS_DBPHZ     = false;// 是否是担保品划转
var QUICKJUMP    = "";	// 快捷跳转页面
const TRADE_LOGIN_DEFAULT_KEY = "trade_login_default_key"; //登录默认值，保存上次的值到本地(营业部，账号类型，对应账号)

LD_ZHLB_NAME = params.ywlx == "ptjy" ? "ptjyLszhList" : "rzrqLszhList";
LD_JZZH_NAME = params.ywlx == "ptjy" ? "ptjyJZZH" : "rzrqJZZH";
LD_LSZH_LSIT = getLocalData (LD_ZHLB_NAME) != null ? JSON.parse (getLocalData (LD_ZHLB_NAME)) : [];
IS_DBPHZ = getLocalData ("jumpDBPHZ") != null;
QUICKJUMP = getLocalData ("quickJump");

var app = angular.module ('Login', []);
const ZJZH_ACCOUNT_TYPE = "zjzh"; //资金账号类型
app.controller ('loginController', function ($rootScope, $scope, $http, $compile) {
    $scope.userAgent = navigator.userAgent;
    //普通交易登录是否显示交易首页的开户按钮
    $scope.isTradeOpenAccountShow = isTradeOpenAccountShow;

    //登录客户号选择是否显示
    $scope.isLoginKHHNodeShow = isLoginKHHNodeShow;

    $scope.Login = function () {
        if (this.validate () == true) {
            var lastUrl = params.ywlx == "ptjy" ? "ptjy/ptyw/login" : "rzrq/ptyw/login";

            // 如果是担保品划转前的登录, 则需要校验提交的账号是否与当前融资融券登录账户的客户号相同
            if (IS_DBPHZ) {

                if (getLocalData ("ActiveRZRQUser")) {

                    if (params.jybblx != "pacific") {
                        var rzrquser = JSON.parse (getLocalData ("ActiveRZRQUser"));

                        if ($("#khbz").val() != rzrquser.head.khbz) {
                            showAlert("此普通交易账号不属于同一个客户", "提示信息");
                            return;
                        }
                    }
                }
                else {
                    console.log ("融资融券的当前用户信息不存在");
                    return;
                }

            }

            var sendParam = getformdata ();
            if (isAppointedCompony(ZQGS_TONGXIN)) { //西藏同信
                var accountType = getAccountType();
                if (accountType == ZJZH_ACCOUNT_TYPE) { //资金账号判断营业部代码
                    sendParam = judgeLoginInfo(sendParam);
                    if (sendParam.notSend) { //不发送信息
                        return;
                    }
                } else if (accountType == "ggh") {
                    var yybDiv = document.getElementById ("yybdmDivList");
                    if (yybDiv) {
                        if (!yybDiv.value) {
                            showAlert("股东代码登录，请选择营业部");
                            return;
                        }
                    }
                }
            }
            if (isAppointedCompony(ZQGS_SHIJI)) { // 世纪证券添加强身份认证头部
                var markInfoString = getMarkInfo();
                // markInfoString = "18028720418,866656021528239,3.0.8.20160121A.66099,null,null,44b575f86fdf5eda,10.10.10.131";
                // markInfoString = "13523252325,,3.0.0.20160128.66097,,,BD701265-86B6-499E-87D7-C2DD637B6B5E,10.10.10.112";
                markInfoArray = markInfoString.split(",");
                //IP+MAC+硬盘序列号+IMEI码+手机号+入网许可证
                if(markInfoArray.length >= 6){
                    sendParam.wldz = markInfoArray[6] + ';' + markInfoArray[4] + ';' + null + ';' + markInfoArray[1] + ';' + markInfoArray[0] + ';' + null;
                }
            }
            ajaxPost (getApiUrl () + lastUrl, sendParam, function (response) {

                // 保存登录账号
                addKhbs (getformdata ().khbz);
                var userInfo = {};
                if (response.dlxx) {
                    //=======要从表单中提取出交易密码==============
                    userInfo["head"] = sendParam;
                    userInfo["body"] = response;
                    var dlxx = response.dlxx;
                    onLoginTrade(dlxx);
                    var dlxxObj = dlxx[0];
                    if (dlxxObj.zjdlrq && dlxxObj.zjdlsj) {
                        setLocalData ("loginLog_" + params.ywlx, {date: dlxxObj.zjdlrq, time: dlxxObj.zjdlsj});
                    }
                    parseUserInfo (params.ywlx, userInfo, response.dlxx[0].khdm, IS_DBPHZ);
                }
                // 如果是担保品划转需要的普通交易登录, 则不需要开始计时
                if (!IS_DBPHZ) {
                    // 调用 APP 锁屏计时器, 开始计时
                    timerAction (params.ywlx == "ptjy" ? params.ptjytimer : params.rzrqtimer, "start");
                }
            })
        }
        else {
            $ ("#vertifyCode").val ("");
        }
    }

    $scope.freshCode = function () {
        createCode ();//刷新验证码
    }

    $scope.autoOpen = function () {
        selfserviceAccount ();
    };

    $scope.validate = function () {
		var khbz=$("#khbz").val();
		var jymm=$("#jymm").val();

	  var inputCode = $("#vertifyCode").val();

	  params.modaltype = 1;

        if (khbz.length == 0) {
            showAlert ("请输入您的账号", "提示信息");
            return false;
        }

        if (jymm.length == 0) {
            showAlert ("请输入您的交易密码", "提示信息");
            return false;
        }

        if (jymm.length < 6) {
            showMessageTips ("交易密码不能少于6位");
            return false;
        }

        if (inputCode.length <= 0) {
            showAlert ("请输入验证码", "提示信息");
        }
        else if (inputCode.toUpperCase () != code) {
            showAlert ("验证码输入错误!", "提示信息");
            createCode ();//刷新验证码
        }
        else {
            return true;
        }

        return false;
    };

    $scope.$watch('$viewContentLoaded', function () {
        if (isAppointedCompony(ZQGS_TONGXIN)) { //西藏同信显示营业部选择，并取值
            var yybList = getLocalData(SALE_DEPARTMENT_INFO_KEY);
            if (yybList) {
                $scope.yybShow = true;
                yybList = JSON.parse(yybList);
                var yybDiv = document.getElementById("yybdmDivList");
                if (yybDiv) {
                    //添加营业部选项列表
                    var item, itemStr, selectInfo;
                    var divStr = "", len = yybList.length;
                    for (var i = 0; i < len; i++) {
                        item = yybList[i];
                        item.index = i;
                        selectInfo = JSON.stringify(item);
                        divStr += '<p  onClick =onYYBListClick(' + selectInfo + ') ><label value=' + item.deptCode + '>' + item.deptName + '</label></p>';
                    }
                    yybDiv.innerHTML = divStr;

                    //默认选择第一项
                    item = yybList[0];
                    yybDiv.value = item.deptCode;
                    var yybNameDiv = document.getElementById("yybdm");
                    if (yybNameDiv) {
                        yybNameDiv.value = item.deptName;
                    }

                    setTimeout(function () {
                        var totalHeight = len * 35;
                        var yybdm = document.getElementById("yybSelectList");
                        var yybY = document.documentElement.clientHeight - yybdm.offsetTop - yybdm.clientHeight - 2;
                        if (totalHeight > yybY) {
                            yybDiv.style.overflow = "auto";
                            yybDiv.style.maxHeight = yybY + "px";
                        }
                    }, 200);
                }

                //重置界面缓存数据
                var localInfo = getLocalData(TRADE_LOGIN_DEFAULT_KEY);
                if (!localInfo) {
                    return;
                }
                localInfo = JSON.parse(localInfo);
                var type = params.ywlx == "ptjy" ? "ptjy" : "rzrq";
                localInfo = localInfo[type];
                if (!localInfo) {
                    return;
                }
                var yybName = localInfo.yybName;
                if (yybName) {
                    document.getElementById("yybdm").value = yybName;
                }

                var yybValue = localInfo.yybValue;
                if (yybValue) {
                    document.getElementById("yybdmDivList").value = yybValue;
                }

                //登录账户类型
                var accountType = localInfo.accountType;
                if (accountType) {
                    var listDom = document.getElementById("khbSelectList");
                    if (listDom) {
                        var nodes = listDom.children;
                        var node;
                        for (var i = 0; i < nodes.length; i++) {
                            if (accountType == nodes[i].children[0].getAttribute("value")) {
                                node = nodes[i].children[0];
                                break;
                            }
                        }
                        if (node) {
                            document.getElementById("khbslx").value = node.innerText;
                            document.getElementById("hid_khbslx").value = node.getAttribute("value");
                            console.log(node.innerText, node.getAttribute("value"));
                        }
                    }
                }
                //登录账户值
                var accountValue = localInfo.accountValue;
                if (accountValue) {
                    document.getElementById("khbz").value = accountValue;
                }
            }
        } else {
            $scope.yybShow = false;
        }
    });
});

app.directive ('onRzrqLoginFinishRender', function ($timeout) {
    return {
        restrict: 'A',
        link: function (scope, element, attr) {
            $timeout (function () {
                if (!isRZRQLoginAccountShow) { //不显示融资融券登录类型选择的时候，替换掉
                    //将整个下拉节点替换为一个存储类型的隐藏文本
                    $ ("#rzrqLoginTypeContainer").replaceWith ('<input type="hidden" id="hid_khbslx" name="khbzlx" isSub="true" value="C"/>');
                }
                if (params.jybblx == "jzwin" || params.jybblx == "pacific") {
                    if (document.getElementById ("hid_khbslx")) {
                        document.getElementById ("hid_khbslx").value = "Z";
                    }
                }
            });
        }
    };
});

//=================西藏同信处理=============================

//保存成功登录后的信息
function saveLoginInfo () {
    if (isAppointedCompony (ZQGS_TONGXIN)) { //西藏同信保存登录信息
        var store = {};
        var dom = document.getElementById("yybdm");
        store.yybName = dom.value;

        dom = document.getElementById("yybdmDivList");
        store.yybValue = dom.value;

        dom = document.getElementById("hid_khbslx");
        store.accountType = dom.value;

        dom = document.getElementById("khbz");
        store.accountValue = dom.value;

        var type = params.ywlx == "ptjy" ? "ptjy" : "rzrq";
        var localData = getLocalData(TRADE_LOGIN_DEFAULT_KEY);
        localData = localData ? JSON.parse(localData) : {};
        localData[type] = store;
        setLocalData(TRADE_LOGIN_DEFAULT_KEY, localData);
    }
}

/* 选择营业部编号**/
function onYYBListClick (selectInfo) {
    var dom = document.getElementById("yybdmDivList");
    dom.value = selectInfo.deptCode;
    dom.selectIndex = selectInfo.index;
};

//获取选择的账号类型
function getAccountType () {
    var accountType = ZJZH_ACCOUNT_TYPE;
    var khbSelectDiv = document.getElementById ("khbslx"); //登录账号节点
    if (khbSelectDiv) {
        var text = khbSelectDiv.value;
        if (text) {
            if (text == "客户号") {
                accountType = "khh";
            } else if (text == "资金账号") {
                accountType = "zjzh";
            } else {
                accountType = "ggh";
            }
        }
    }
    return accountType;
}


// 西藏通信做营业部代码拼接（需求见西藏同信文档 9.3）
function judgeLoginInfo (param) {
        var khbzLen = param.khbz.length;
        const CORRECT_LEN = 12;//正确的长度
        if (khbzLen == CORRECT_LEN) {
            return param;
        }
        if (khbzLen > CORRECT_LEN || (khbzLen >= 9 && khbzLen <= 11)) {
            //showAlert ("资金账号为12位，请重新输入", "信息提示")
            showAlert ("资金账号为12位，请重新输入","提示信息");
            param.notSend = true;
            return param;
        }

        var yybDom = document.getElementById ("yybdmDivList"); //营业部dom
        if (!yybDom) {
            return param;
        }
        var yybdm = yybDom.value;
        if (!yybdm) {
            return param;
        }
        var khbz = param.khbz;
        var coverNum = CORRECT_LEN - khbz.length - yybdm.length;
        if (coverNum > 0) {
            for (var i = 0; i < coverNum; i++) {
                yybdm += "0";
            }
        }
        yybdm += khbz;
        param.khbz = yybdm;
        return param;
}


/*=========================================================
 函数功能：删除登录账号历史输入信息
 入参说明；index	按索引删除
 num 	按账号删除
 ==========================================================*/
function del_khbsList (index, num) {
    event = event || window.event;
    event.stopPropagation ();

    // 按钮账号删除
    if (num != undefined) {
        for (var i = 0; i < LD_LSZH_LSIT.length; i++) {
            if (num == LD_LSZH_LSIT[i]) {
                index = i;
                break;
            }
        }
    }

    // 按索引删除
    else {
        // 记住账号与删除的账号相同, 则把记住的账号删除
        if (getLocalData (LD_JZZH_NAME) == LD_LSZH_LSIT[index]) {
            $ ("#khbz").val ("");
            removeLocalData (LD_JZZH_NAME);
        }
    }

    //从指定位置删除一个元素
    LD_LSZH_LSIT.splice (index, 1);

    // 账号下拉框重新生成显示数据
    Khbs_add_selelct ();

    // 将新的登录账号数据保存到本地存储
    setLocalData (LD_ZHLB_NAME, LD_LSZH_LSIT);
}

/*=========================================================
 函数功能：登录账号数据添加到下拉框
 ==========================================================*/
function Khbs_add_selelct () {
    // 清空下拉框数据
    $ (".khbsList").empty ();

    // 动态添加数据到下拉框中
    for (var i = LD_LSZH_LSIT.length - 1; i > -1; i--) {
        $ (".khbsList").append ('<p><label>' + LD_LSZH_LSIT[i] + '</label><a onclick="del_khbsList(' + i + ')"></a></p>');
    }
}

//将成功登录的客户标识本地存储起来
function addKhbs (obj) {
    //是否需要保存账号
    var isSave = $ ("#remember").attr ("checked") != undefined;
    //是否已保存
    var isExist = false;

    //for (var i = 0; i < LD_LSZH_LSIT.length; i++) {
    //    if (LD_LSZH_LSIT[i] == obj) //当前账号在本地存储已存在
    //    {
    //        isExist = true;
    //        break;
    //    }
    //}

    //已经存储了就不需要再保存了,并放到第一个
    var tempIndex = -1;
    var len = LD_LSZH_LSIT.length;
    for (var index = 0; index < len; index++) {
        if (tempIndex != -1) {
            LD_LSZH_LSIT[tempIndex] = LD_LSZH_LSIT[index];
            tempIndex = index;
        } else {
            if (LD_LSZH_LSIT[index] == obj) //当前账号在本地存储已存在
            {
                isExist = true;
                tempIndex = index;
            }
        }
    }
    if (tempIndex != -1) {
        LD_LSZH_LSIT[len - 1] = obj;
    }

    if (isSave) {
        if (!isExist)//
        {
            //当客户标识存储数量超过5个或5个时，删除第一个
            if (LD_LSZH_LSIT.length > 4) {
                LD_LSZH_LSIT.shift ();
            }
            LD_LSZH_LSIT.push (obj);
        }
        setLocalData (LD_ZHLB_NAME, LD_LSZH_LSIT);
        setLocalData (LD_JZZH_NAME, obj);
        saveLoginInfo();
    }
    else {
        if (isExist)//存在不需要保存则删除
        {
            del_khbsList (0, obj)
        }
        removeLocalData (LD_JZZH_NAME);
    }
}

/**======== 客户标识 历史输入记录下拉框显示 end ===========*/

var code; //在全局 定义验证码

function createCode () {
    code = "";
    var codeLength = 4;//验证码的长度
    //'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
    var selectChar = new Array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9);//所有候选组成验证码的字符，当然也可以用中文的
    for (var i = 0; i < codeLength; i++) {
        var charIndex = Math.floor (Math.random () * 10);
        code += selectChar[charIndex];
    }

    $ ("#checkCode").text (code);

}

/*=========================================
 函数功能：显示客户号下拉框列表
 =========================================*/
function showKhbs () {
    if (getLocalData (LD_JZZH_NAME)) {
        $ ("#remember").addClass ("checked");
        $ ("#remember").attr ("checked", true);

        var remember = getLocalData (LD_JZZH_NAME);

        // 客户账号
        $ ("#khbz").val (remember == undefined || remember == null || remember == "undefined" ? "" : remember);
    }

    if (LD_LSZH_LSIT.length > 0) {
        $ (".div1").find (".input-group").addClass ("sel_right");
    }
}

/*
 *	自定义键盘回调函数【重写】
 *	@param param	键盘输入的值
 */
function fillInputContent (param) {
    var $obj = $ ("#" + params.id),
        _val = $obj.val (),
        isDel = param == "del";

    if (isDel) {
        $obj.val (_val.substring (0, _val.length - 1));
    } else {

        // 交易密码最大长度只能为8位
        if (params.id == "jymm" && $obj.val ().length >= 8) {
            // 西藏同信交易密码最大限度改为11位
            if (isAppointedCompony(ZQGS_TONGXIN)) {
                if ($obj.val ().length >= 11){

                } else {
                    $obj.val (_val + param);
                }
            }
        } else {
            $obj.val (_val + param);
        }

    }

    // 是否隐藏 DIV 下拉框
    if (params.isHideDivSelect) {
        $ ("#" + params.id).nextAll (".divselect").removeClass ("dis").hide ();
        params.isHideDivSelect = false;
    }

    // 验证码输入正确后, 隐藏自定义键盘
    if (params.id == "vertifyCode") {
        var vertifyCode = $obj.val ();
        var isHIDE = vertifyCode.length == 4 && vertifyCode.toUpperCase () == code ? true : false;
        if (isHIDE) {
            hideKeyBoard ();
        }
    }

}

/*====================================================
 触发条件：点击页面复选框按钮
 执行功能：1、动态设置样式,达到实现切换图片的目的
 ====================================================*/
$ ("input[type=checkbox]").click (function () {
    var ID = $ (this).attr ("id");
    var khbs = $ ("#khbs").val ();

    if ($ (this).attr ("checked")) {
        $ (this).removeClass ("checked");
        removeLocalData (ID);
        $ (this).removeAttr ("checked");
    }
    else {
        setLocalData (ID, khbs);
        $ (this).addClass ("checked");
        $ (this).attr ("checked", true);
    }
});


/************************** 初始化处理  ************************************/
$ (window).load (function () {
    createCode ();		// 创建并显示验证码
    showKhbs ();			//显示客户号下拉框列表

    //融资融券
    if (params.ywlx == "rzrq") {
        // 金证 win 版只显示信用资金账号
        if (params.jybblx == "jzwin" || params.jybblx == "pacific") {
            if (document.getElementById ("khbslx")) {
                document.getElementById ("khbslx").value = "资金账号";
                //document.getElementById ("khbslx").value = "信用资金账号";
            }

            if (document.getElementById ("hid_khbslx")) {
                document.getElementById ("hid_khbslx").value = "Z";
            }

            if (document.getElementById ("khbz")) {
                document.getElementById ("khbz").setAttribute ("placeholder", "请输入您的信用资金账号");
            }
        }
    }

    // 如果是担保品划转前的登录操作, 默认显示客户号
    // 删除担保品划转在本地存储中状态
    if (IS_DBPHZ) {
        if (params.ywlx == "ptjy") {

            if (params.jybblx == "pacific") {
                document.getElementById ("khbslx").value = "资金账号";
                document.getElementById ("hid_khbslx").value = "Z";

                document.getElementById ("khbz").setAttribute ("placeholder", "普通资金账号");
                document.getElementById ("khbz").value = "";
            }
            else {
                document.getElementById ("khbslx").value = "客户号";
                document.getElementById ("hid_khbslx").value = "C";

                document.getElementById ("khbz").setAttribute ("placeholder", "普通客户号");

                if (getLocalData ("ActiveRZRQUser")) {
                    var user = JSON.parse (getLocalData ("ActiveRZRQUser"));

                    console.log (user);

                    document.getElementById ("khbz").value = user.head.khbz;
                }
            }

        }

        removeLocalData ("jumpDBPHZ");
        // 在担保品划转前登录界面, 需要先删除本地存储中的快捷跳转, 防止在正常普通交易登录时还存在该快捷跳转
        removeLocalData ("quickJump");
    }

});

