/**
 * 新股申购详细页面
 * $Date: 2015-07-13 15:35:20 +0800 (周一, 2015-07-13) $
 * $Revision: 4530 $
 * $Author: guoqf $
 */

var ywlx            = $("body").attr("data-ywlx");
var dataList        = getLocalData("dataList");         //  从本地存储中获取上一页面中新股信息
var newdate         = (new Date()).Format("yyyyMMdd");  // 当前日期
var step            = 1000;                             // 步长  沪市 1000 , 深市 500
var kmmslcx_success = false;                            // 可买卖数量查询是否成功

var app = angular.module('xgxq', []);

app.controller('xgxqController', function($rootScope, $scope, $http, $compile)
{

var modal_level     = 1;                                // 模态框级别
dataList = dataList == null ? {} : JSON.parse(dataList);

$scope.userAgent    = navigator.userAgent;
$scope.stockName    = dataList.zqmc || "";
$scope.stockCode    = dataList.zqdm || "";
$scope.purchase     = "申购";
$scope.dis_sq_btn   = true;

// 当天是发行日期, 可以点击申购
if(dataList.fxrq == newdate)
{
  $scope.dis_sq_btn   = false;
}

// 网上申购上限(元)  如果服务器没有下发数据, 则 "待定" 显示.
var wssgsx_y = isNaN(dataList.wsfxsl) ? dataList.wsfxsl : isNaN(dataList.fxjg) ? dataList.fxjg : formatNumber(amount_calculation(dataList.sgxe, dataList.fxjg), 0)

$scope.rowDetails   = [
  { name: "申购日期"            , value: formatDate(dataList.fxrq || "", "yyyy-MM-dd")},
  { name: "资金解冻日"          , value: formatDate(dataList.zjjdrq || "", "yyyy-MM-dd")},
  { name: "发行价格"            , value: dataList.fxjg || "" },
  { name: "发行市盈率(倍)"      , value: (!isNaN(dataList.fxsyl) ? dataList.fxsyl + "%" : dataList.fxsyl)},
  { name: "总发行数量(万股)"    , value: parseFloatW(dataList.zfxsl)},
  { name: "网上发行数量(万股)"  , value: parseFloatW(dataList.wsfxsl)},
  { name: "网上申购上限(万股)"  , value: parseFloatW(dataList.sgxe)},
  { name: "网上申购上限(元)"    , value: wssgsx_y}
];


/*$scope.baseContent = "万达电影院线股份有限公司是国内领先的影院投资及运营商。2010年和2012年，公司两次获得CINEASIA（亚太电影博览会）颁发的\“年度放映商\”大奖。&hellip，公司两次获得，公司两次，公司两次获得，公司两次获得获得，公司两次获得，公司两次获得";

$scope.newsTitles = [
  { name:"万达院线四涨停股价近翻番 机构看高到80元"         , value: "2015-01-15 07:50"},
  { name:"习近平批准有关军队发展党员工作规定"              , value: "2015-01-15 08:18"},
  { name:"百视通合并东方明珠获批 剑指互联网电视"           , value: "2015-34-13 08:06"},
  { name:"希拉里宣布参选美国总统：原做美国民众\"捍卫者\""  , value: "2015-4-13 09:23"},
];*/

// 屏蔽显示数据
$scope.baseContent = "";
$scope.newsTitles = [];

/*==========================================================
  触发条件：点击页面 [ 申购 ] 按钮
===========================================================*/
$scope.sq_btn = function()
{
  // 显示申购的模态框
  sg_show_modal();
}

/*==============================================
  触发条件：点击模态框中的 [ + ] 按钮
  执行功能：
===============================================*/
$scope.plus = function()
{
  if(check_number("+"))
  {
    plusMinus("number", "plus", step);
  }

  //显示金额
  show_price($scope, modal, "number");
}

/*==============================================
  触发条件：点击模态框中的 [ - ] 按钮
  执行功能：
===============================================*/
$scope.minus = function()
{
  if(check_number("-"))
  {
     plusMinus("number", "minus", step);
  }

  //显示金额
  show_price($scope, modal, "number");
}

/*===========================
  显示APP自定义键盘
============================*/
$scope.showKeyboard = function(id)
{
  showKeyboard(id,'1');
}

/*==============================================
  触发条件：点击模态框中的 [ 确定 ] 按钮
  执行功能：
===============================================*/
$scope.Ensure = function()
{
  if(modal_level == 1) {            // 申购模态框点击 “确定” 按钮

    var tips = "";

    // 如果申购限制等于 0 , 则不能申购新股
    if(maxNumber == 0)  tips = "您的申购限额为 0, 无法下单";

    var number = $("#number").val();
    number = number.trim() == "" ? 0 : number;

    if(!kmmslcx_success) tips = "可买卖数量查询失败";

    if(number == 0) tips = "请输入申购数量";

    // 申购数量为所在交易所申购单位的整数倍; 深市: 500, 沪市: 1000
    if(parseFloat(number) % step > 0) tips = "申购数量应为" + step + "股整数倍";

    if(tips != "") {
      showMessageTips(tips, "40");
      return;
    }

    // 因为申购数量可能是键盘输入, 需要重新计算下显示金额
    show_price($scope, modal, "number");

    // 委托数量
    dataList['wtsl'] = $("#number").val();
    // 申购金额
    dataList['sgje'] = modal['numbersMsg'][0].value;

    // 关闭模态框
    CloseModal();

    // 申购确认模态框
    sgqr_show_modal();
  }
  else if(modal_level == 10) {      // 申购确认模态框点击 “确定” 按钮
    // 关闭模态框
    CloseModal();

    // 委托下单
    wtxd_order();
  }
  else if(modal_level == 100) {     // 委托下单后显示的模态框点击 “确定” 按钮
    // 关闭模态框
    CloseModal();

    //刷新页面
    window.location.reload();
  }
  else {
    // 关闭模态框
    CloseModal();
  }
};

/*=============================================
  函数功能：申购显示的模态框
==============================================*/
function sg_show_modal()
{
  modal_level = 1;

  modal = {};

  //深市步长 500 ,  沪市步长 1000
  step = dataList.jysdm == "0" || dataList.jysdm == "2" ? 500 : 1000;
  xg_fxjg = dataList.fxjg;

  modal["title"] = "申购";

  modal["content"] = [
    {"key": "证券名称",   "value": dataList.zqmc},
    {"key": "证券代码",   "value": dataList.zqdm},
    {"key": "最多可申购", "value": dataList.sgxe + "股"},
  ];

  // 解析股东代码
  var gddms = parseGddmList(dataList.jysdm);

  // 用户没有股东代码时
  if(gddms.length == 0)
  {
    showMessageTips("您没有 [" + dataList.zqdm  + "] 所在交易所的股东代码，不能进行申购!", "40");
    return;
  }

  // 用户股东代码数大于 1 时，显示股东代码列表由客户选择
  if(gddms.length > 1)
  {
    modal["select"] = [{key:"股东代码",opteions:[]}];

    modal["select"][0]['options'] = [];

    for(var i in gddms) {
      modal["select"][0]['options'].push({value: gddms[i], text: gddms[i]});
    }

    // 设置默认显示的股东代码
    modal["select"][0]['options']['selectVal'] = gddms[0];
  }

  var sqje = calculate_price(dataList.sgxe, dataList.fxjg) + "元";

  modal['numbers']    = [{id: "number", plus: "BtnPlusRed",  minus: "BtnMinusRed", value: ""}];

  modal['numbersMsg'] = [{key: "金额：", value: sqje}];

  modal['footerMsg']  = [{value:footerMsg(dataList.jysdm)}];

  // 创建模态框
  create_modal($scope, $compile, modal);

  // 申购限额
  maxNumber = dataList.sgxe;
  // 股东代码
  dataList['gddm'] = gddms.length == 1 ? gddms[0] : modal["select"][0]['options']['selectVal'];

  // 初始化可买卖数量查询状态
  kmmslcx_success = true;

  // 延迟加载
  setTimeout(function(){
    $("#number").val(maxNumber);
  }, 200);
}

/*=============================================
  函数功能：可买卖数量查询
==============================================*/
function kmmslcxQuery(zqdm,gddm,jysdm,wtjg,method)
{
  var request = {zqdm:zqdm,gddm:gddm,jysdm:jysdm,mmlb:"P",wtjg:wtjg};

  var lastUrl = "ptjy/xgsg/kmmslcx";

  if(ywlx == "rzrq")
  {
    request.ywlx = "rzrq";
    lastUrl      = "rzrq/xgsg/kmmslcx";
  }

  ajaxPost(getApiUrl() + lastUrl, request, function(response){
    method(response);
  });
}

/*================================================
  函数功能：申购确认显示的模态框
================================================*/
function sgqr_show_modal()
{
  modal_level = 10;

  modal = {};

  modal["title"] = "申购确认";

  modal["content"] = [
    {"key": "证券代码","value": dataList.zqdm},
    {"key": "证券名称","value": dataList.zqmc},
    {"key": "申购数量","value": dataList.wtsl || "0"},
    {"key": "申购金额","value": dataList.sgje || "0"}
  ];

  // 创建模态框
  create_modal($scope, $compile, modal);
}

/*================================================
  函数功能：委托下单
================================================*/
function wtxd_order()
{
  var request = {
    jysdm: dataList.jysdm,
    gddm: dataList.gddm,
    mmlb: "B",
    zqdm: dataList.sgdm,
    wtjg: dataList.fxjg,
    wtsl: dataList.wtsl
  };

  console.log(JSON.stringify(request));
  var lastUrl = "ptjy/xgsg/wtxd";

  if(ywlx == "rzrq")
  {
    request.ywlx = "rzrq";
    lastUrl      = "rzrq/xgsg/wtxd";
  }

  ajaxPost(getApiUrl() + lastUrl, request, function(response) {
    wtxd_show_modal(params.message.xgsg_success);
  });
}

/*================================================
  函数功能：委托下单显示的模态框
================================================*/
function wtxd_show_modal(msg)
{
  modal_level = 100;

  modal = {};

  modal["title"] = "申购";

  modal["msg"] = [{ value: msg }];

  // 创建模态框
  create_modal($scope, $compile, modal, true);
}

}); // angularjs 控制器结束


// 现在没有用到, 可以注释掉

//段落省略号插件
// (function($){
//     $.fn.ellipsis = function(options){
//         //插件参数
//         options = $.extend({
//             //英文模式
//             english : false,
//             //优化系数
//             OP_NUM: 1.3,
//             //目标行数
//             lineNum : 3,
//         }, options);
//         $(this).each(function(index, element) {
//             //优化系数
//             var OP_NUM = options.OP_NUM;
//             //wrap
//             var $wrap = $(this);
//             //目标p
//             var $p = $('p',$wrap);
//             //行数
//             var lineNum = options.lineNum;
//             //最初整篇文章
//             var originAll = $p.text();
//              //字体大小
//             var pFontSize = parseInt($p.css('font-size'));
//               //行高
//             var pLineHeight = parseInt($p.css('line-height'));
//             // 过去宽度
//             var oldWidth = $p.width();
//             // 现在宽度
//             var nowWidth = oldWidth;
//             //根据行数设置wrap高度
//             var wrapHeight = lineNum * pLineHeight;
//             $wrap.height(wrapHeight);
//             // 英文模式，字符偏多，系数*2.5
//             OP_NUM = options.english ? 1.3*2.5 : 1.3;
//             //首次加载先进行一次粗略筛选
//             $p.text(originAll.slice(0,lineNum * nowWidth/pFontSize * OP_NUM));
//             //主功能
//             function render(){
//                 nowWidth = $p.width();
//                 //当页面放大时，粗略筛选
//                 if(nowWidth > oldWidth){
//                     $p.text(originAll.slice(0,lineNum * nowWidth/pFontSize * OP_NUM));
//                 }
//                 oldWidth = nowWidth;
//                 //核心筛选
//                 while ($p.outerHeight() > wrapHeight) {
//                     $p.text($p.text().replace(/\s?(\w+|\W{1,3})(\.{6})?$/, "......"));
//                 };
//             }
//             render();
//             // 窗口拉伸;
//             $(window).resize(function(){
//                 //利用异步将页面渲染操作合在一起
//                 setTimeout(render,0);
//             })
//         });
//     };
// })(jQuery);
